//A simple table model, just like a defaultablemodel but allows you to specify which columns are editable 
//
//

import java.awt.*;
import java.awt.event.*;
import java.util.*;
import java.util.List;

import javax.swing.*;
import javax.swing.event.TableModelEvent;
import javax.swing.event.TableModelListener;
import javax.swing.table.*;

public class RaveUneditableTableModel extends DefaultTableModel {
    protected DefaultTableModel tableModel;
    public int[] rowStatus;
    public boolean[] isEditable;
    
    public RaveUneditableTableModel(Object rowData[][], Object columnNames[]) {
        super(rowData,columnNames);
        
        boolean[] isEditable = new boolean[this.getColumnCount()];
        this.isEditable = isEditable;

    }
    
    public void setIsEditable(Object[] newEditable) {
        for (int i = 0; i < newEditable.length; i++)
            this.isEditable[i] = (Boolean)newEditable[i];
    }
    
    public boolean[] getIsEditable() {
        return isEditable;
    }
    
    @Override
    public boolean isCellEditable(int row, int column) {
        return isEditable[column];        
    }
        
    public Class getColumnClass(int col) {
        try {
            if (getRowCount() > 0)
                return getValueAt(0, col).getClass();
            else
                return "".getClass();
        }
        catch (Exception e)
        {
            return "".getClass();  
        }
    }

}

