function handles=raveupdatestandalonecolorbarxdials(src,ev,handles,thesevars)
%
% RAVE Rapid Analysis and Visualization Environment
% Copyright (C) 2010 Georgia Tech Research Corporation
% ALL RIGHTS RESERVED
%
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU General Public License
% as published by the Free Software Foundation; version 2
% of the License.
%
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
handles=guidata(src);

%get format inputs:
udata=get(handles.fakeax(handles.activeindex),'userdata');
d=udata.view.dataset;
a=udata.view.analysis;


thisvalue=raveevaluatefunction(handles.fig,udata.view.dataset,udata.view.c,handles.xdials{udata.view.dataset}{udata.view.analysis},handles);
   

ai=handles.activeindex;
legdata=get(handles.fakerax(ai),'userdata');
cbar=findobj(legdata,'tag','Colorbar');
oldlim=udata.view.clim;
newlim=[handles.minlimit{d}{a}(udata.view.c) handles.maxlimit{d}{a}(udata.view.c)];
udata.view.clim=newlim;
set(handles.fakeax(ai),'userdata',udata);
ylim=get(cbar,'ylim');
if ~all(oldlim==newlim)
    raveupdatecolorbar(handles.fig,[],ai);
    legdata=get(handles.fakerax(ai),'userdata');
    cbar=findobj(legdata,'tag','Colorbar');
end

thiscoord=interp1(newlim,ylim,thisvalue);
%make triangle patch at this value:
cvpatch=findobj(cbar,'tag','currentvalue');
set(cvpatch,'ydata',[thiscoord-1.5 thiscoord+1.5 thiscoord]);
cvtext=findobj(cbar,'tag','currentvaluetxt');
pos=get(cvtext,'pos');
set(cvtext,'pos',[pos(1) thiscoord],'string',sprintf('%5.5g',thisvalue));






