function viewtabsurfaceprofiler(src,eventdata) %#ok<INUSD>
%
% RAVE Rapid Analysis and Visualization Environment
% Copyright (C) 2010 Georgia Tech Research Corporation
% ALL RIGHTS RESERVED
%
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU General Public License
% as published by the Free Software Foundation; version 2
% of the License.
%
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
%RAVE: creates uicontrols on the view tab for line graphs.

handles=guidata(src);

%move front tabs to front if necessary
% if handles.fronttabsfront==0 %swap fronttabs and backtabs
set(handles.fronttabaxes,'position',handles.fronttabposition)
set(handles.backtabaxes,'position',handles.backtabposition)
[x,y,v]=calculatetabprofile(handles.backtabprofile,.1,1,0); %#ok<NASGU>
set(handles.backtablines,'xdata',x,'ydata',y);
% end
% handles.fronttabsfront=1;

[x,y,v]=calculatetabprofile(handles.fronttabprofile,.1,2,1); %#ok<NASGU>
set(handles.fronttablines,'xdata',x,'ydata',y)

set(handles.infobar,'string','');

origin=get(handles.tabaxes,'position');

%% clear existing tab
%delete(handles.tabobjects)

%% get input info from graph:
udata=get(handles.fakeax(handles.activeindex),'userdata');
d=udata.view.dataset;
a=udata.view.analysis;

%% text headers
projecttext=text(.15-.10317,.95*1.0317-.0317,'Project','horizontalalignment','left','backgroundcolor',handles.colors.tabbg,...
    'parent',handles.tabaxes,'fontsize',handles.fonts.titlesize,'fontname',handles.fonts.title,'color',handles.colors.title);
dataseriestext=text(.15-.10317,.77*1.0317-.0317,'Data Series','horizontalalignment','left','backgroundcolor',handles.colors.tabbg,...
    'parent',handles.tabaxes,'fontsize',handles.fonts.titlesize,'fontname',handles.fonts.title,'color',handles.colors.title);
optionstext=text(.15-.10317,.16*1.0317-.0317,'Options','horizontalalignment','left','backgroundcolor',handles.colors.tabbg,...
    'parent',handles.tabaxes,'fontsize',handles.fonts.titlesize,'fontname',handles.fonts.title,'color',handles.colors.title,'visible','off');

%% text labels
analysistext=text(.25-.10317,.920*1.0317-.0317,'Choose Parent Analysis:','horizontalalignment','left',...
    'backgroundcolor',handles.colors.tabbg,...
    'parent',handles.tabaxes,'fontsize',10,'fontname','arial','color',[0 0 0],'fontweight','bold','backgroundcolor','none');
datasettext=text(.25-.10317,.85*1.0317-.0317,'Choose a Data Set:','horizontalalignment','left',...
    'backgroundcolor',handles.colors.tabbg,...
    'parent',handles.tabaxes,'fontsize',10,'fontname','arial','color',[0 0 0],'fontweight','bold');
xaxistext=text(.25-.10317,.74*1.0317-.0317,'X-Axis Variable:','horizontalalignment','left',...
    'backgroundcolor',handles.colors.tabbg,...
    'parent',handles.tabaxes,'fontsize',10,'fontname','arial','color',[0 0 0],'fontweight','bold');
yaxistext=text(.25-.10317,.67*1.0317-.0317,'Y-Axis Variable:','horizontalalignment','left',...
    'backgroundcolor',handles.colors.tabbg,...
    'parent',handles.tabaxes,'fontsize',10,'fontname','arial','color',[0 0 0],'fontweight','bold');
zaxistext=text(.25-.10317,.60*1.0317-.0317,'Z-Axis Variable:','horizontalalignment','left',...
    'backgroundcolor',handles.colors.tabbg,...
    'parent',handles.tabaxes,'fontsize',10,'fontname','arial','color',[0 0 0],'fontweight','bold');
colortext=text(.25-.10317,.53*1.0317-.0317,'Color Surface by:','horizontalalignment','left',...
    'backgroundcolor',handles.colors.tabbg,...
    'parent',handles.tabaxes,'fontsize',10,'fontname','arial','color',[0 0 0],'fontweight','bold');


%% variable lists


%make list of resposne names:
allnames=handles.allnames{d};
respnames=allnames(logical(handles.isfunction{d}));
inputnames=allnames(~logical(handles.isfunction{d}) & ~logical(handles.isconstant{d}));

%convert z column into resposne column number:

xvalue=find(ismember(inputnames,allnames(udata.view.x)));
yvalue=find(ismember(inputnames,allnames(udata.view.y)));
zvalue=find(ismember(respnames,allnames(udata.view.z)));
cvalue=find(ismember(respnames,allnames(udata.view.c)));

analysismenu=uicontrol('position',[origin(1)+55 origin(2)+535 180 30],...
    'style','popupmenu','string',handles.analysisnames,'callback',@analysismenu_callback,...
    'backgroundcolor',[1 1 1],'tag','analysismenu','value',udata.view.analysis);
datasetmenu=uicontrol('position',[origin(1)+55 origin(2)+490 180 30],...
    'style','popupmenu','string',handles.datasetnames,'callback',@datasetmenu_callback,...
    'backgroundcolor',[1 1 1],'tag','datasetmenu','value',udata.view.dataset);
xaxismenu=uicontrol('position',[origin(1)+55 origin(2)+421 180 30],...
    'style','popupmenu','string',inputnames,'callback',@xaxismenu_callback,...
    'backgroundcolor',[1 1 1],'tag','xaxismenu','value',xvalue);
yaxismenu=uicontrol('position',[origin(1)+55 origin(2)+376 180 30],...
    'style','popupmenu','string',inputnames,'callback',@yaxismenu_callback,...
    'backgroundcolor',[1 1 1],'tag','yaxismenu','value',yvalue);
zaxismenu=uicontrol('position',[origin(1)+55 origin(2)+331 180 30],...
    'style','popupmenu','string',respnames,'callback',@zaxismenu_callback,...
    'backgroundcolor',[1 1 1],'tag','zaxismenu','value',zvalue);
colormenu=uicontrol('position',[origin(1)+55 origin(2)+286 180 30],...
    'style','popupmenu','string',[respnames(1:end),cellstr('<Solid Color>')],'callback',@colormenu_callback,...
    'backgroundcolor',[1 1 1],'tag','colormenu','value',length(handles.allnames{1}),'value',cvalue);

currentpointcheck=uicontrol('position',[origin(1)+55 origin(2)+256 180 30],...
    'style','checkbox','string','Show current point on surface','callback',@showcurrentpoint_callback,...
    'backgroundcolor',[1 1 1],'value',udata.view.showcurrentpoint);


%% buttons
changeunitsbutton=uicontrol('position',[origin(1)+55 origin(2)+38 180 30],...
    'style','pushbutton','string','Change Units','backgroundcolor',handles.colors.buttonbg,'enable','off','visible','off');


% try
%     idata=imread(fullfile(matlabroot,'/toolbox/matlab/icons/tool_rotate_3d.png'),'backgroundcolor',handles.colors.togglebuttonbg);
%     idata=double(idata)./(255^2);
%     %alpha=double(alpha)./(255^2);
%
%     idata(idata>1)=1;
%     %alpha(alpha>1)=1;
%
%     cdata=ones(26,200,3);
%     cdata(:,:,1)=cdata(:,:,1).*handles.colors.togglebuttonbg(1);
%     cdata(:,:,2)=cdata(:,:,2).*handles.colors.togglebuttonbg(2);
%     cdata(:,:,3)=cdata(:,:,3).*handles.colors.togglebuttonbg(3);
%     cdata(5:20,7:22,:)=idata;
%     cdata=uint8(cdata.*255);
% catch
%     cdata=[];
% end

%make pixel coordinates:
% rotatebutton=drawtogglebutton(handles.fig,[origin(1)+45 origin(2)+5 200 26],handles.colors.togglebuttonbg,cdata,'    Enable 3D Graph Rotation',@rotate3dbutton_callback,handles.rotater);
% set(rotatebutton,'tag','rotate3dtoggle','visible','off');
%






%% group items and finish up
handles.tabobjects=[datasettext xaxistext yaxistext colortext datasetmenu xaxismenu yaxismenu colormenu,...
    analysistext projecttext analysismenu dataseriestext optionstext ,...
    changeunitsbutton zaxistext zaxismenu currentpointcheck];
%handles.tabobjects=[handles.tabobjects h];



handles.activetab='view';

guidata(src,handles);
% update menus to hide excluded vars


%% Here be callbacks:%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function datasetmenu_callback(src,eventdata) %#ok<INUSD>

handles=guidata(src);
udata=get(handles.fakeax(handles.activeindex),'userdata');

udata.view.dataset=get(src,'value');

set(handles.fakeax(handles.activeindex),'userdata',udata);
handles.graphdataset(handles.activeindex)=get(src,'value');
guidata(src,handles);

ravecreatesurfaceprofiler(src,[]);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function analysismenu_callback(src,eventdata) %#ok<INUSD>
handles=guidata(src);
handles.graphanalysis(handles.activeindex)=get(src,'value');
guidata(src,handles);

udata=get(handles.fakeax(handles.activeindex),'userdata');
udata.view.analysis=get(src,'value');
set(handles.fakeax(handles.activeindex),'userdata',udata);

ravecreatesurfaceprofiler(src,[]);


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function xaxismenu_callback(src,eventdata) %#ok<INUSD>
handles=guidata(src);
udata=get(handles.fakeax(handles.activeindex),'userdata');

allvars=handles.allnames{udata.view.dataset};
inputvars=get(src,'string');
thisvar=inputvars(get(src,'value'));

udata.view.x=find(ismember(allvars,thisvar));

set(handles.fakeax(handles.activeindex),'userdata',udata);

ravecreatesurfaceprofiler(src,[]);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function yaxismenu_callback(src,eventdata) %#ok<INUSD>

handles=guidata(src);
udata=get(handles.fakeax(handles.activeindex),'userdata');

allvars=handles.allnames{udata.view.dataset};
inputvars=get(src,'string');
thisvar=inputvars(get(src,'value'));

udata.view.y=find(ismember(allvars,thisvar));

set(handles.fakeax(handles.activeindex),'userdata',udata);

ravecreatesurfaceprofiler(src,[]);


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function zaxismenu_callback(src,eventdata) %#ok<INUSD>
handles=guidata(src);
udata=get(handles.fakeax(handles.activeindex),'userdata');

allvars=handles.allnames{udata.view.dataset};
respvars=get(src,'string');
thisvar=respvars(get(src,'value'));

udata.view.z=find(ismember(allvars,thisvar));

set(handles.fakeax(handles.activeindex),'userdata',udata);

ravecreatesurfaceprofiler(src,[]);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function colormenu_callback(src,eventdata) %#ok<INUSD>
handles=guidata(src);
udata=get(handles.fakeax(handles.activeindex),'userdata');

allvars=handles.allnames{udata.view.dataset};
respvars=get(src,'string');
thisvar=respvars(get(src,'value'));

udata.view.c=find(ismember(allvars,thisvar));

set(handles.fakeax(handles.activeindex),'userdata',udata);

ravecreatesurfaceprofiler(src,[]);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function showcurrentpoint_callback(src,ev) %#ok<INUSD>
handles=guidata(src);
udata=get(handles.fakeax(handles.activeindex),'userdata');
udata.view.showcurrentpoint=get(src,'value');
set(handles.fakeax(handles.activeindex),'userdata',udata);
ravecreatesurfaceprofiler(handles.fig,[]);













