function preferenceslidersclick(src,ev)
%NOTE: all of these functions need to work REGARDLESS OF WHICH GRAPH IS
%SELECTED. so no using activeindex or activegraph!
%
% RAVE Rapid Analysis and Visualization Environment
% Copyright (C) 2010 Georgia Tech Research Corporation
% ALL RIGHTS RESERVED
% 
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU General Public License
% as published by the Free Software Foundation; version 2
% of the License.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.

handles=guidata(src);
set(handles.fig,'windowbuttonmotionfcn',{@pprofslide,src})
set(handles.fig,'windowbuttonupfcn',{@pprofdone,src})

function pprofslide(fig,eventdata,blob) %#ok<INUSL>
handles=guidata(fig);
ai=find(handles.allgraphs==get(blob,'parent'));
udata=get(handles.fakeax(ai),'userdata');

d=udata.view.dataset;
a=udata.view.analysis;

thisvar=get(gco,'userdata');

if ~isempty(fig) %if this function is called as a callback: (get mouse location and slide bars)
    clicked=get(get(blob,'parent'),'currentpoint');
    val=clicked(1,1);

    %move marker within bounds
    if val>0.7299998
        val=0.7299998;
    elseif val<0.43
        val=0.43;
    end

    newval=((val-0.43)/0.3).^2;
    set(gco,'xdata',val,'markerfacecolor',udata.format.cmap(round((newval^.25)*127)+1,:));
    valtext=strtrim(sprintf(udata.format.formatstring,newval));
    set(udata.view.valtexts(udata.view.blobs==blob),'string',valtext,'color',udata.format.textcolor);
    handles.preferences{udata.view.dataset}(thisvar)=newval;
    
    %if normalize preferences, adjust all other blobs too:
    if handles.normalizepreferences{d}
        index=udata.view.x~=thisvar;
        allprefs=handles.preferences{d}(udata.view.x); %if preference=0, keep it at zero. 
        multiplier=(1-newval)./sum(allprefs(index));
        if isnan(multiplier) || isinf(multiplier);multiplier=0;end
        newprefs=handles.preferences{d}(udata.view.x(index)).*multiplier;
        handles.preferences{d}(udata.view.x(index))=newprefs;
       
        set(udata.view.blobs(index),{'xdata'},num2cell(sqrt(newprefs').*0.3+0.43),...
            {'markerfacecolor'},mat2cell(udata.format.cmap(round((newprefs.^.25)'.*127)+1,:),ones(numel(newprefs),1),3));
        set(udata.view.valtexts(index),{'string'},cellstr(num2str(newprefs',udata.format.formatstring)));

    end

end

guidata(handles.fig,handles);

if handles.prefs.alwaysupdate && ~handles.prefs.alwaysrasterize
    raveupdatedataset(fig,handles,'preferences',ai,udata.view.dataset);
end

function pprofdone(src,eventdata,fig) %#ok<INUSL>
handles=guidata(fig);
set(handles.fig,'windowbuttonmotionfcn',@ravedefaultwindowbuttonmotionfcn)
set(handles.fig,'windowbuttonupfcn','')

ai=find(handles.allgraphs==get(gco,'parent'));
udata=get(handles.fakeax(ai),'userdata');

%get blob positions and save these values:
vals=cell2mat(get(udata.view.blobs,'xdata'));
newvals=((vals-0.43)/0.3).^2;

d=udata.view.dataset;
a=udata.view.analysis;

handles.preferences{d}=zeros(size(handles.preferences{d})); %set all unplotted preferences to zero.
handles.preferences{d}(udata.view.x)=newvals;

raveupdatedataset(fig,handles,'preferences',ai,udata.view.dataset);





