function filterapplyfilter(src,ev)
%First input MUST be the main axes of the filter to be applied (i.e. the
%one stored in handles.allgraphs)
%
% RAVE Rapid Analysis and Visualization Environment
% Copyright (C) 2011 Georgia Tech Research Corporation
% ALL RIGHTS RESERVED
% 
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU General Public License
% as published by the Free Software Foundation; version 2
% of the License.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.

handles=guidata(src);

ai=find(handles.allgraphs==src,1);

udata=get(handles.fakeax(ai),'userdata');

d=udata.view.dataset;
a=udata.view.analysis;

handles.isfiltered{d}{a}=ravecalculatefilteredstate(src,[],d,a);

inrows=~handles.isfiltered{d}{a};
outrows=handles.isfiltered{d}{a};


updateselection=false;
updatevisible=false;

if udata.view.autoselectin
    handles.isselected{d}{a}=inrows;
    updateselection=true;
end

if udata.view.autoselectout
    handles.isselected{d}{a}=outrows;
    updateselection=true;
end

if udata.view.autohidein
    handles.isvisible{d}{a}=outrows;
    updatevisible=true;
end

if udata.view.autohideout
    handles.isvisible{d}{a}=inrows;
    updatevisible=true;
end

if updateselection
    handles=raveupdateanalysis(src,handles,'isselected',[],d,a);
end

if updatevisible
    handles=raveupdateanalysis(src,handles,'visiblerows',[],d,a);
end

guidata(handles.fig,handles);
raveupdateanalysis(handles.fig,handles,'isfiltered',[],d,a);

if ~handles.prefs.filteredselectable
    
    wasselected=handles.isselected{d}{a};
    
    handles.isselected{d}{a}=handles.isselected{d}{a} & ~handles.isfiltered{d}{a};
    guidata(handles.fig,handles);
    
    %Did selection actually change?
    if all(wasselected==handles.isselected{d}{a})
        return
    end
    
    raveupdateanalysis(handles.fig,handles,'isselected',[],d,a);
end 




