function filterbarclick(src,ev)
%
% RAVE Rapid Analysis and Visualization Environment
% Copyright (C) 2010 Georgia Tech Research Corporation
% ALL RIGHTS RESERVED
% 
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU General Public License
% as published by the Free Software Foundation; version 2
% of the License.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
%NOTE: all of these functions need to work REGARDLESS OF WHICH GRAPH IS
%SELECTED. so no using activeindex or activegraph!
handles=guidata(src);
ai=find(handles.allgraphs==get(src,'parent'));
udata=get(handles.fakeax(ai),'userdata'); 

clicked=get(get(src,'parent'),'currentpoint');
val=clicked(1,1);
handles.temp.initialval=val;
 idx=udata.view.blobs==src;
handles.temp.initialrange=[get(udata.view.lowfilterblobs(idx),'xdata') get(udata.view.highfilterblobs(idx),'xdata')];
guidata(handles.fig,handles);

set(handles.fig,'windowbuttonmotionfcn',{@filterbarslide,src})
set(handles.fig,'windowbuttonupfcn',{@filterbardone,src})

function filterbarslide(fig,eventdata,src) %#ok<INUSL>
handles=guidata(fig);
ai=find(handles.allgraphs==get(src,'parent'));
udata=get(handles.fakeax(ai),'userdata'); 

d=udata.view.dataset;
a=udata.view.analysis;

thisvar=get(gco,'userdata');
thistype=handles.datatype{udata.view.dataset}{thisvar};
allowablevalues=handles.discretevalues{udata.view.dataset}{udata.view.analysis}{thisvar};

if ~isempty(fig) %if this function is called as a callback: (get mouse location and slide bars)
    clicked=get(get(src,'parent'),'currentpoint');
    val=clicked(1,1);

    %move marker within bounds
    idx=udata.view.blobs==src;
    %range=[get(udata.view.lowfilterblobs(idx),'xdata') get(udata.view.highfilterblobs(idx),'xdata')];
    range=handles.temp.initialrange;
    
    delta=val-handles.temp.initialval;
    
    newrange=range+delta;
    
    if newrange(1)<0.43
        delta=0.43-range(1);        
    elseif newrange(2)>0.73
        delta=0.73-range(2);
    end
    
    %apply corrected delta:
    newrange=range+delta; 
    val=newrange;
    
    
   %round to nearest allowable point:
    if ~any(strcmp(thistype,{'continuous','integer'}))
        allowed=linspace(.43,.73,numel(allowablevalues));
        
        v=allowed(abs(allowed-val(1))==min(abs(allowed-val(1))));
        val(1)=v(1); %in case above line has 2 mins.
        newval(1)=find(abs(allowed-val(1))==min(abs(allowed-val(1))));
        
        v=allowed(abs(allowed-val(2))==min(abs(allowed-val(2))));
        val(2)=v(1); %in case above line has 2 mins.
        newval(2)=find(abs(allowed-val(2))==min(abs(allowed-val(2))));

    else
        range=[handles.minlimit{d}{a}(thisvar) handles.maxlimit{d}{a}(thisvar)];
        %range=magicbox.ranges(thisvar,:);
        if range(1)-range(2)==0;return;end %avoids errors with constant variables.
        newval=range(1)+((val-0.43)/0.3)*(range(2)-range(1));
    end
    
    newrange=val;
    
    
    set(udata.view.lowfilterblobs(idx),'xdata',newrange(1));
    set(udata.view.highfilterblobs(idx),'xdata',newrange(2));
    set(udata.view.blobs(idx),'xdata',newrange)

  %convert range to numerical values:
    
    
    
    
    %make current value texts:
    if ~any(strcmp(thistype,{'string','logical','discrete','integer'}))
        valtext1=strtrim(sprintf(udata.format.formatstring,newval(1)));
        valtext2=strtrim(sprintf(udata.format.formatstring,newval(2)));
    elseif strcmp(thistype,'integer')
        valtext1=strtrim(sprintf(udata.format.formatstring,round(newval(1))));
        valtext2=strtrim(sprintf(udata.format.formatstring,round(newval(2))));
    elseif strcmp(thistype,'discrete')
        newval=allowablevalues(newval);
        valtext1=strtrim(sprintf(udata.format.formatstring,newval(1)));
        valtext2=strtrim(sprintf(udata.format.formatstring,newval(2)));
        
    elseif strcmp(thistype,'string')
        valtext1=handles.discretevalues{d}{a}{thisvar}{newval(1)};
        valtext2=handles.discretevalues{d}{a}{thisvar}{newval(2)};
        
        %valtext=newval;
    else %logical
        valtext1=handles.prefs.logicalfalse;
        valtext2=handles.prefs.logicaltrue;
      
    end

    udata.view.lowfilters(thisvar)=newval(1);
    set(udata.view.minvaltexts(idx),'string',valtext1,'color',[0 0 0]);

    udata.view.highfilters(thisvar)=newval(2);
    set(udata.view.maxvaltexts(idx),'string',valtext2,'color',[0 0 0]);

end

%set(udata.view.blobs(idx),'xdata',xdata);
set(handles.fakeax(ai),'userdata',udata);

%update global filters:
handles.minfilter{d}{a}=udata.view.lowfilters;
handles.maxfilter{d}{a}=udata.view.highfilters;

%update discrete filters:
switch handles.datatype{d}{thisvar}
    case 'string'
        newval=false(size(handles.discretefilter{d}{a}{thisvar}));
        newval(udata.view.lowfilters(thisvar):udata.view.highfilters(thisvar))=true;
        handles.discretefilter{d}{a}{thisvar}=newval(:);
    case {'discrete','integer','logical'};       
        discretevalues=handles.discretevalues{d}{a}{thisvar};
        newval=discretevalues>=udata.view.lowfilters(thisvar) & discretevalues<=udata.view.highfilters(thisvar);
        handles.discretefilter{d}{a}{thisvar}=newval(:);
end

guidata(handles.fig,handles);

%update on slide if desired:
 if handles.prefs.alwaysupdate && ~handles.prefs.alwaysrasterize
    filterapplyfilter(get(src,'parent'),[]);
 end

function filterbardone(fig,eventdata,src) %#ok<INUSL>
handles=guidata(fig);
set(handles.fig,'windowbuttonmotionfcn',@ravedefaultwindowbuttonmotionfcn)
set(handles.fig,'windowbuttonupfcn','')

filterapplyfilter(get(src,'parent'),[]);

