function handles=raveupdatefilterisfiltered(src,ev,handles)
%
% RAVE Rapid Analysis and Visualization Environment
% Copyright (C) 2010 Georgia Tech Research Corporation
% ALL RIGHTS RESERVED
% 
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU General Public License
% as published by the Free Software Foundation; version 2
% of the License.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.handles=guidata(src);

%handles=guidata(src);
getudata;

targetaxes=handles.activegraph; %=handles.activegraph
xcol=udata.view.x;
a=udata.view.analysis;
d=udata.view.dataset; %data set index


udata.view.lowfilters=handles.minfilter{d}{a};
udata.view.highfilters=handles.maxfilter{d}{a};

%% make magic box:

allnames=handles.allnames{d};
varnames=allnames(xcol);
ranges=[handles.minlimit{d}{a}(xcol)' handles.maxlimit{d}{a}(xcol)'];
datatypes=handles.datatype{d}(xcol);
%raveresizeaxes(src,[],handles.activeindex)
axpos=get(targetaxes,'position');
nvars=numel(varnames);

rpix=14.7; %pixels per row of text. 
tpix=rpix*(nvars+1); %total number of pixels needed to display all vars.
dpix = axpos(4); %number of pixels visible at any time. 

ndisp=floor(axpos(4)/rpix); %number of rows of text that will fit in the box

maxvals=udata.view.highfilters(xcol);
minvals=udata.view.lowfilters(xcol);

%normalize xdials to range used in magicbox:
startvalues=(minvals-ranges(:,1)')./(ranges(:,2)'-ranges(:,1)')*.3+.43;
startvalues(isinf(startvalues))=0.58; %mid range.
startvalues(isnan(startvalues))=0.58;

endvalues=(maxvals-ranges(:,1)')./(ranges(:,2)'-ranges(:,1)')*.3+.43;
endvalues(isinf(endvalues))=0.58; %mid range.
endvalues(isnan(endvalues))=0.58;

%make box:
downer=rpix/2;

for t=1:nvars
    thisvar=xcol(end-t+1);
    thistype=datatypes{end-t+1};
    minval=minvals(end-t+1);
    maxval=maxvals(end-t+1);
    
    %make current value texts:
    if ~any(strcmp(thistype,{'string','logical','integer','discrete'}))
      maxvaltext=strtrim(sprintf(udata.format.formatstring,maxval));
        minvaltext=strtrim(sprintf(udata.format.formatstring,minval));  
    elseif strcmp(thistype,'integer')
        maxvaltext=strtrim(sprintf(udata.format.formatstring,floor(maxval)));
        minvaltext=strtrim(sprintf(udata.format.formatstring,ceil(minval)));
    elseif strcmp(thistype,'discrete')
        maxvaltext=strtrim(sprintf(udata.format.formatstring,maxval));
        minvaltext=strtrim(sprintf(udata.format.formatstring,minval));
    elseif strcmp(thistype,'string')
        maxvaltext=handles.discretevalues{d}{a}{thisvar}{maxval};
        minvaltext=handles.discretevalues{d}{a}{thisvar}{minval};
    else %logical
        maxvaltext=handles.prefs.logicaltrue;
        minvaltext=handles.prefs.logicalfalse;
    end

        startcolor=[0 0 0];

 %   text(0.0,t/ndisp*dpix,varnames{end-t+1},'horizontalalignment','left','clipping','on','verticalalignment','top','parent',targetaxes);
    
    set(udata.view.blobs(end-t+1),'xdata',[startvalues(end-t+1) endvalues(end-t+1)]);
    
%     
%     L(t)=line([0.43 .505 .580 .655 .730],repmat(t/ndisp*dpix-downer,[1 5]),'linewidth',1,...
%         'color',[0 0 0],'marker','+','parent',targetaxes,'hittest','off');
%     
    set(udata.view.lowfilterblobs(end-t+1),'xdata',startvalues(end-t+1));
     
    set(udata.view.highfilterblobs(end-t+1),'xdata',endvalues(end-t+1));
  
    set(udata.view.minvaltexts(end-t+1),'string',minvaltext);
    
    set(udata.view.maxvaltexts(end-t+1),'string',maxvaltext);
end

%set(targetaxes,'ylim',[tpix-dpix tpix]);

%% make slider:
% slpos=[axpos(1)+axpos(3) axpos(2)-1 17 axpos(4)+1];
% 
% vscroll=drawvscroll(handles.wspanel,targetaxes,slpos,0,tpix,dpix,tpix,@sliderscroll,1);
% 
% udata.view.scroll=vscroll;

set(handles.fakeax(handles.activeindex),'userdata',udata);
