function formattabgraphaxes(src,eventdata)
%rave format tab.
%
% RAVE Rapid Analysis and Visualization Environment
% Copyright (C) 2010 Georgia Tech Research Corporation
% ALL RIGHTS RESERVED
%
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU General Public License
% as published by the Free Software Foundation; version 2
% of the License.
%
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.

handles=guidata(src);
udata=get(handles.fakeax(handles.activeindex),'userdata');

%move front tabs to front if necessary
% if handles.fronttabsfront==0 %move swap fronttabs and backtabs
set(handles.fronttabaxes,'position',handles.fronttabposition)
set(handles.backtabaxes,'position',handles.backtabposition)
[x,y,v]=calculatetabprofile(handles.backtabprofile,.1,1,0);
set(handles.backtablines,'xdata',x,'ydata',y);
% end
% handles.fronttabsfront=1;

[x,y,v]=calculatetabprofile(handles.fronttabprofile,.1,3,1);
set(handles.fronttablines,'xdata',x,'ydata',y)

origin=get(handles.tabaxes,'position');


%% clear existing tab
delete(handles.tabobjects)

%% do work

t=uicontrol('style','text','position',[origin(1)+10 origin(2)+600 240 22],...
    'string','Layout:','backgroundcolor',handles.colors.tabbg,'fontsize',10,'fontweight','bold','hor','left');

if strcmp(udata.format.layout,'vertical')
    val=1;
else
    val=2;
end

tt=uicontrol('style','popupmenu','position',[origin(1)+10 origin(2)+580 240 20],...
    'string',{'Vertical','Horizontal','Two Column','Two Row'},'backgroundcolor',handles.colors.tabbg,'value',val,'callback',@layout_callback);


xaxistext=text(.15-.10317,.72*1.0317-.0317+0.17,'X-Axis Menu Label:','horizontalalignment','left',...
    'backgroundcolor',handles.colors.tabbg,...
    'parent',handles.tabaxes,'fontsize',10,'fontname','arial','color',[0 0 0],'fontweight','bold');
yaxistext=text(.15-.10317,.65*1.0317-.0317+0.17,'Y-Axis Menu Label:','horizontalalignment','left',...
    'backgroundcolor',handles.colors.tabbg,...
    'parent',handles.tabaxes,'fontsize',10,'fontname','arial','color',[0 0 0],'fontweight','bold');
zaxistext=text(.15-.10317,.58*1.0317-.0317+0.17,'Z-Axis Menu Label:','horizontalalignment','left',...
    'backgroundcolor',handles.colors.tabbg,...
    'parent',handles.tabaxes,'fontsize',10,'fontname','arial','color',[0 0 0],'fontweight','bold');
colortext=text(.15-.10317,.51*1.0317-.0317+0.17,'C-Axis Menu Label:','horizontalalignment','left',...
    'backgroundcolor',handles.colors.tabbg,...
    'parent',handles.tabaxes,'fontsize',10,'fontname','arial','color',[0 0 0],'fontweight','bold');
sizetext=text(.15-.10317,.44*1.0317-.0317+0.17,'S-Axis Menu Label:','horizontalalignment','left',...
    'backgroundcolor',handles.colors.tabbg,...
    'parent',handles.tabaxes,'fontsize',10,'fontname','arial','color',[0 0 0],'fontweight','bold');


%% variable lists
xaxisedit=uicontrol('position',[origin(1)+20 origin(2)+405+10+108 180 22],...
    'style','edit','string',udata.view.X.label,'callback',@xaxisedit_callback,...
    'backgroundcolor',[1 1 1],'tag','xaxismenu','value',udata.view.x,'hor','left');
yaxisedit=uicontrol('position',[origin(1)+20 origin(2)+360+10+108 180 22],...
    'style','edit','string',udata.view.Y.label,'callback',@yaxisedit_callback,...
    'backgroundcolor',[1 1 1],'tag','yaxismenu','value',udata.view.y,'hor','left');
zaxisedit=uicontrol('position',[origin(1)+20 origin(2)+315+10+108 180 22],...
    'style','edit','string',udata.view.Z.label,'callback',@zaxisedit_callback,...
    'backgroundcolor',[1 1 1],'tag','zaxismenu','value',udata.view.z,'hor','left');
coloredit=uicontrol('position',[origin(1)+20 origin(2)+270+10+108 180 22],...
    'style','edit','string',udata.view.C.label,'callback',@caxisedit_callback,...
    'backgroundcolor',[1 1 1],'tag','colormenu','value',udata.view.c+1,'hor','left');
sizeedit=uicontrol('position',[origin(1)+20 origin(2)+225+10+108 180 22],...
    'style','edit','string',udata.view.S.label,'callback',@saxisedit_callback,...
    'backgroundcolor',[1 1 1],'tag','sizemenu','value',udata.view.s+1,'hor','left');

%% group items and finish up
handles.tabobjects=[t,tt,xaxistext,yaxistext,zaxistext,colortext,sizetext,xaxisedit,yaxisedit,zaxisedit,coloredit,sizeedit];

handles.activetab='format';
set(handles.infobar,'string','');
guidata(src,handles);

function layout_callback(src,ev)
handles=guidata(src);
udata=get(handles.fakeax(handles.activeindex),'userdata');

if get(src,'value')==1
    udata.format.layout='vertical';
elseif  get(src,'value')==2
    udata.format.layout='horizontal';
elseif get(src,'value')==3
    udata.format.layout='twocol';
elseif get(src,'value')==4
    udata.format.layout='tworow';
end

set(handles.fakeax(handles.activeindex),'userdata',udata);
ravearrangeobjectsgraphaxes(src,ev)

function xaxisedit_callback(src,ev)
handles=guidata(src);
udata=get(handles.fakeax(handles.activeindex),'userdata');
newlabel=get(src,'string');
udata.view.X.label=newlabel;
set(handles.fakeax(handles.activeindex),'userdata',udata);
set(udata.view.X.menutext,'string',newlabel);

function yaxisedit_callback(src,ev)
handles=guidata(src);
udata=get(handles.fakeax(handles.activeindex),'userdata');
newlabel=get(src,'string');
udata.view.Y.label=newlabel;
set(handles.fakeax(handles.activeindex),'userdata',udata);
set(udata.view.Y.menutext,'string',newlabel);

function zaxisedit_callback(src,ev)
handles=guidata(src);
udata=get(handles.fakeax(handles.activeindex),'userdata');
newlabel=get(src,'string');
udata.view.Z.label=newlabel;
set(handles.fakeax(handles.activeindex),'userdata',udata);
set(udata.view.Z.menutext,'string',newlabel);

function caxisedit_callback(src,ev)
handles=guidata(src);
udata=get(handles.fakeax(handles.activeindex),'userdata');
newlabel=get(src,'string');
udata.view.C.label=newlabel;
set(handles.fakeax(handles.activeindex),'userdata',udata);
set(udata.view.C.menutext,'string',newlabel);

function saxisedit_callback(src,ev)
handles=guidata(src);
udata=get(handles.fakeax(handles.activeindex),'userdata');
newlabel=get(src,'string');
udata.view.S.label=newlabel;
set(handles.fakeax(handles.activeindex),'userdata',udata);
set(udata.view.S.menutext,'string',newlabel);


