function boxselectscatter(src,ev) 
handles=guidata(src);
ai=find(handles.allgraphs==gca);
udata=get(handles.fakeax(ai),'userdata');

clicked=get(gca,'currentpoint');

xclick=clicked(1,1,1);
yclick=clicked(1,2,1);
handles.temp.startx=xclick;
handles.temp.starty=yclick;

handles.temp.selection=rectangle('position',[xclick yclick eps(xclick) eps(yclick)],'linewidth',1,'edgecolor',[1 .5 0],...
    'parent',src,'hittest','off','buttondownfcn','','facecolor','none','clipping','on');

set(handles.temp.selection,'userdata',false(size(handles.isselected{udata.view.dataset}{udata.view.analysis})));

%maintain manual/auto sizing:
handles.temp.axesmode=get(gca,'xlimmode');
set(src,'xlimmode','manual','ylimmode','manual');

%allow dragging
set(handles.fig,'WindowButtonMotionFcn',@ravesizeselection);
set(handles.fig,'WindowButtonUpFcn',@ravesizeselectiondone);
set(handles.fig,'windowbuttondownfcn',[]);

guidata(src,handles);




function ravesizeselection(src,eventdata) %#ok<INUSD>
handles=guidata(src);
datasets=raveguidata(src,'datasets');
ai=find(handles.allgraphs==gca);
udata=get(handles.fakeax(ai),'userdata');

finish=get(gca,'currentpoint');
starty=handles.temp.starty;
startx=handles.temp.startx;
endx=finish(1,1,1);
endy=finish(1,2,1);

pos1=min(startx,endx);
pos3=max(startx,endx)-pos1;
pos2=min(starty,endy);
pos4=max(starty,endy)-pos2;

try %#ok<TRYNC>
    set(handles.temp.selection,'position',[pos1 pos2 pos3 pos4]);
end
%determine which points are in this rectangle:

try
    inpoints=raveinsidepoly(datasets.alldata{udata.view.dataset}(:,udata.view.x),datasets.alldata{udata.view.dataset}(:,udata.view.y),[pos1 pos1 pos1+pos3 pos1+pos3],[pos2 pos2+pos4 pos2+pos4 pos2]);
catch %#ok<CTCH>
    inpoints=inpolygon(datasets.alldata{udata.view.dataset}(:,udata.view.x),datasets.alldata{udata.view.dataset}(:,udata.view.y),[pos1 pos1 pos1+pos3 pos1+pos3],[pos2 pos2+pos4 pos2+pos4 pos2]);
end

if strcmp(get(handles.fig,'currentmodifier'),'shift')
    inpoints = handles.isselected{udata.view.dataset}{udata.view.analysis} | inpoints;
elseif strcmp(get(handles.fig,'currentmodifier'),'alt')
    lastselected=handles.isselected{udata.view.dataset}{udata.view.analysis};
    lastselected(inpoints)=false;
    inpoints= lastselected;
elseif strcmp(get(handles.fig,'currentmodifier'),'control')
    inpoints= handles.isselected{udata.view.dataset}{udata.view.analysis} & inpoints;
end

[mainrows,selectedrows,filteredrows]=ravemakeplotdataseries(handles,udata);

if ~handles.prefs.filteredselectable
    inpoints=inpoints & mainrows;
else
    inpoints=inpoints & (mainrows | filteredrows);
end

set(handles.infobar,'string',[strtrim(sprintf('%12.0f',sum(inpoints))) ' points selected'])

updatescatterisselected(handles.fig,ai,inpoints,handles)

set(handles.temp.selection,'userdata',inpoints)


function ravesizeselectiondone(src,eventdata) %#ok<INUSD>
handles=guidata(src);
datasets=raveguidata(src,'datasets');
ai=find(handles.allgraphs==gca);
udata=get(handles.fakeax(ai),'userdata');
%stop dragging
set(handles.fig,'WindowButtonMotionFcn',@ravedefaultwindowbuttonmotionfcn);
set(handles.fig,'WindowButtonUpFcn',[]);
set(gca,'xlimmode',handles.temp.axesmode,'ylimmode',handles.temp.axesmode)

set(handles.infobar,'string','');

inpoints=get(handles.temp.selection,'userdata');
delete(handles.temp.selection);

set(handles.infobar,'string',[strtrim(sprintf('%12.0f',sum(inpoints))) ' points selected'])

%store indices of selected points.
%inpoints=get(handles.temp.selected,'userdata');

handles.isselected{udata.view.dataset}{udata.view.analysis}=inpoints;

%update other graphs:
handles=raveupdateanalysis(src,handles,'isselected',[],udata.view.dataset,udata.view.analysis);

if handles.prefs.setxdialswhensingleselected && sum(inpoints)==1
    handles.xdials{udata.view.dataset}{udata.view.analysis}=datasets.alldata{udata.view.dataset}(inpoints,:);
    raveupdateanalysis(src,handles,'xdials',[],udata.view.dataset,udata.view.analysis);
end
