function pointselectscatter(src,ev)
handles=guidata(src);
datasets=raveguidata(handles.fig,'datasets');

set(handles.infobar,'string','Shift+Click to add points to current selection, Alt+Click to remove from selection');
%determine which point was clicked:
handles=guidata(src);

if strcmp(get(src,'type'),'axes')
    raveunselectfcn(src,[]);
    return
end

ai=find(handles.allgraphs==ancestor(src,'axes'));
udata=get(handles.fakeax(ai),'userdata');

d=udata.view.dataset;
a=udata.view.analysis;

handles.temp.selected=findobj(handles.allgraphs(ai),'tag','selected');
clicked=get(handles.allgraphs(ai),'currentpoint');

xclick=clicked(1,1,1);
yclick=clicked(1,2,1);

[mainrows,selectedrows,filteredrows]=ravemakeplotdataseries(handles,udata);
inrows=mainrows;
%copied from ravefindclosestpoint2D, to work with custom data set:

xdata=datasets.alldata{d}(inrows,udata.view.x);
ydata=datasets.alldata{d}(inrows,udata.view.y);

activegraph=get(src,'parent');

pos=getpixelposition(activegraph);
xlim=get(activegraph,'xlim');
ylim=get(activegraph,'ylim');

%make conversion factors, units to pixels:

xconvert=(xlim(2)-xlim(1))/pos(3);
yconvert=(ylim(2)-ylim(1))/pos(4);

Xclick=(xclick-xlim(1))/xconvert;
Yclick=(yclick-ylim(1))/yconvert;

Xdata=(xdata-xlim(1))/xconvert;
Ydata=(ydata-ylim(1))/yconvert;

Xdiff=Xdata-Xclick;
Ydiff=Ydata-Yclick;

distnce=sqrt(Xdiff.^2+Ydiff.^2);

index=distnce==min(distnce);

index=index(:); %make sure it's a column.

if sum(index)>1
    thispoint=find(distnce==min(distnce),1);
    index=false(size(distnce));
    index(thispoint)=true;
end

inpoints=find(inrows);
inpoints=inpoints(index);

realpoints=false(size(handles.isvisible{d}{a}));
realpoints(inpoints)=true;
%
inpoints=realpoints;

if strcmp(get(handles.fig,'currentmodifier'),'shift')
    inpoints=handles.isselected{d}{a} | inpoints;
elseif strcmp(get(handles.fig,'currentmodifier'),'alt')
    lastselected=handles.isselected{d}{a};
    lastselected(inpoints)=false;
    inpoints=lastselected;
end

handles.isselected{d}{a}=inpoints;

%update other graphs:
handles=raveupdateanalysis(src,handles,'isselected',[],d,a);

if handles.prefs.setxdialswhensingleselected && sum(inpoints)==1
    handles.xdials{d}{a}=datasets.alldata{udata.view.dataset}(inpoints,:);
    raveupdateanalysis(src,handles,'xdials',[],d,a);
end

