function handles=raveupdatescatterrowcolors(src,ev,handles)
%
% RAVE Rapid Analysis and Visualization Environment
% Copyright (C) 2010 Georgia Tech Research Corporation
% ALL RIGHTS RESERVED
% 
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU General Public License
% as published by the Free Software Foundation; version 2
% of the License.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
%handles=guidata(src);

datasets=raveguidata(handles.fig,'datasets');
ai=handles.activeindex;
udata=get(handles.fakeax(ai),'userdata');

if udata.view.c==0
    c=ravemakerowcdata(handles,datasets,udata,udata.view.c,udata.format.mcmap);
else
    return
end

[mainrows,selectedrows,filteredrows]=ravemakeplotdataseries(handles,udata);

patchidx=udata.view.patchidx;

if ~udata.view.uselines
    %main handles
    for j=1:max(patchidx)
        mainidx=patchidx==j & mainrows;
        if any(mainidx)
            set(udata.view.mainhandles(j),'cdata',c(mainidx));
        end
    end
else
    for j=1:10
        xdata=datasets.alldata{udata.view.dataset}(:,udata.view.x);
        ydata=datasets.alldata{udata.view.dataset}(:,udata.view.y);
        
        mainidx=handles.rowcolors{udata.view.dataset}{udata.view.analysis}==j & ~filteredrows & mainrows;
        if any(mainidx)
            set(udata.view.mainhandles(j),'xdata',xdata(mainidx),'ydata',ydata(mainidx),'visible','on');
        else
            set(udata.view.mainhandles(j),'visible','off');
        end
    end
end

%Update legend:
leg=get(handles.fakerax(handles.activeindex),'userdata');
leg = leg(ishandle(leg));
trueleg = findobj(leg,'flat','-not','tag','Colorbar');
if ~isempty(trueleg)
    legpos = get(trueleg,'position');
    legpos=[legpos(1) legpos(2)+legpos(4)];
else
    legpos=[];
end
delete(leg);

guidata(handles.fig,handles); %need to update handles so ravemakerowcolorlegend can access it. 

%Make row color legend
ccol = udata.view.c;
d = udata.view.dataset;
a = udata.view.analysis;
if ccol==0 && numel(unique(handles.rowcolors{d}{a}))>1
    L = ravemakerowcolorlegend(src,[],d,a,handles.activeindex,legpos);
    legdata = get(handles.fakerax(handles.activeindex),'userdata');
    legdata = union(legdata,L);
    legdata = legdata(ishandle(legdata));
    set(handles.fakerax(handles.activeindex),'userdata',legdata);
end


