function updatescatterisselected(src,ai,selectedrows,handles)
%updates the scatter plot with index ai to display the selection in
%isselected (logical)

if nargin<4
    handles=guidata(src);
end

datasets=raveguidata(handles.fig,'datasets');
udata=get(handles.fakeax(ai),'userdata');

d=udata.view.dataset;
a=udata.view.analysis;

x=datasets.alldata{d}(:,udata.view.x);
y=datasets.alldata{d}(:,udata.view.y);
z=1:numel(x);

if nargin<3 || isempty(selectedrows)
    %isselected=handles.isselected{d}{a};
    [mainrows,selectedrows,filteredrows]=ravemakeplotdataseries(handles,udata);    
end

%nothidden=handles.isvisible{d}{a};


selpatchhandles=udata.view.selhandles;
patchidx=udata.view.patchidx;
npatches=numel(udata.view.mainhandles);
%selected handles

if ~udata.view.uselines
    for j=1:npatches
        selidx=patchidx==j & selectedrows;
        if any(selidx)
            set(selpatchhandles(j),'xdata',x(selidx),'ydata',y(selidx),'visible','on');
        else
            set(selpatchhandles(j),'visible','off');
        end
    end
else
    selidx=selectedrows;
    if any(selidx)
        set(selpatchhandles,'xdata',x(selidx),'ydata',y(selidx),'visible','on');
    else
        set(selpatchhandles,'visible','off');
    end
end



