function ravemouseoverscatter3Ddata(src,ev,ai)

%return

%persistent handles udata

handles=guidata(src);

if handles.prefs.mouseoverdelay>0
    set(handles.mousetimer,'TimerFcn',{@processmouseover,handles,ai})
    stop(handles.mousetimer);
    start(handles.mousetimer);
else %process immediately
    processmouseover(handles,ai);    
end

function processmouseover(src,ev,handles,ai)
datasets=raveguidata(handles.fig,'datasets');
udata=get(handles.fakeax(ai),'userdata');

%show mouseovertext:
loc=get(handles.allgraphs(ai),'currentpoint');

%make uv coordinates:
%check that they clicked on current graph:
z = get(handles.allgraphs(ai),'CameraTarget') - get(handles.allgraphs(ai),'CameraPosition');
z = z./norm(z,2);
u = rand(1,3);
u = u - dot(z,u).*z;
u = u./norm(u);
v = cross(u,z);

d=udata.view.dataset;
a=udata.view.analysis;

clicked=get(handles.allgraphs(ai),'currentpoint');

xclick=clicked(1,1,1);
yclick=clicked(1,2,1);
zclick=clicked(1,3,1);
point=[xclick yclick zclick];

uclick = dot(point,u);
vclick = dot(point,v);


%convert xclick/yclick to pixels.
xdata=datasets.alldata{udata.view.dataset}(:,udata.view.x);
ydata=datasets.alldata{udata.view.dataset}(:,udata.view.y);
zdata=datasets.alldata{udata.view.dataset}(:,udata.view.z);

nothidden=handles.isvisible{d}{a};

%project this data into uv plane:
pointdata=[xdata(:) ydata(:) zdata(:)];
pointdata=pointdata(nothidden,:);

uudata=pointdata*u';
vdata=pointdata*v';

ulim=[min(uudata) max(uudata)];
vlim=[min(vdata) max(vdata)];

Uclick=(uclick-ulim(1))/(ulim(2)-ulim(1));
Vclick=(vclick-vlim(1))/(vlim(2)-vlim(1));

Udata=(uudata-ulim(1))/(ulim(2)-ulim(1));
Vdata=(vdata-vlim(1))/(vlim(2)-vlim(1));

Udiff=Udata-Uclick;
Vdiff=Vdata-Vclick;

distnce=sqrt(Udiff.^2+Vdiff.^2);

isfiltered=handles.isfiltered{d}{a};
distnce(isfiltered)=inf;

index = distnce==min(distnce);

index=index(:); %make sure it's a column.

if sum(index)>1
    thispoint=find(distnce==min(distnce),1);
    index=false(size(distnce));
    index(thispoint)=true;
end

idx=find(index);

xcol=udata.view.x;
ycol=udata.view.y;
zcol=udata.view.z;

%calculate pixel offsets:
pos=get(handles.allgraphs(ai),'position');
xlim=get(handles.allgraphs(ai),'xlim');
ylim=get(handles.allgraphs(ai),'ylim');
zlim=get(handles.allgraphs(ai),'zlim');

[azel]=get(handles.allgraphs(ai),'view');
az=azel(1)*pi/180;
el=azel(2)*pi/180;

xpix=(xlim(2)-xlim(1))./(pos(3)*cos(az));
ypix=(ylim(2)-ylim(1))./(pos(4)*sin(az));
zpix=(zlim(2)-zlim(1))./(pos(4)*cos(el));

xoff=6*cos(az);
yoff=6*sin(az);
zoff=6*cos(el);

d=udata.view.dataset;

%show highlight marker:
%determine size:

if udata.view.s==0
    s=sqrt(udata.format.minmarkersize);
else
    s=datasets.alldata{d}(idx,udata.view.s);
    minsize=udata.format.minmarkersize;
    maxsize=udata.format.maxmarkersize;
    
    mins=min(datasets.alldata{d}(:,udata.view.s));
    maxs=max(datasets.alldata{d}(:,udata.view.s));
    
    if mins~=maxs %avoid divide by zero
        s=(((s-mins)/(maxs-mins)).^2)*maxsize + minsize;% + rand(length(x),1)/100;
        s=sqrt(round(s)+1);
    else
        s=sqrt(udata.format.minmarkersize);
    end
end

set(udata.explore.mouseoverhandles(1),'xdata',datasets.alldata{d}(idx,xcol),'ydata',datasets.alldata{d}(idx,ycol),...
    'zdata',datasets.alldata{d}(idx,zcol),'markersize',s,'visible','on');

%show text label:
set(udata.explore.mouseoverhandles(2),'position',datasets.alldata{udata.view.dataset}(idx,[xcol ycol zcol])+[(xoff-1)*xpix (yoff+s*0.75)*ypix (zoff+s*0.75)*zpix])
set(udata.explore.mouseoverhandles(3),'position',datasets.alldata{udata.view.dataset}(idx,[xcol ycol zcol])+[(xoff+1)*xpix (yoff+s*0.75)*ypix (zoff+s*0.75)*zpix])
set(udata.explore.mouseoverhandles(4),'position',datasets.alldata{udata.view.dataset}(idx,[xcol ycol zcol])+[xoff*xpix (yoff+1+s*0.75)*ypix (zoff+s*0.75)*zpix])
set(udata.explore.mouseoverhandles(5),'position',datasets.alldata{udata.view.dataset}(idx,[xcol ycol zcol])+[xoff*xpix (yoff-1+s*0.75)*ypix (zoff+s*0.75)*zpix])
set(udata.explore.mouseoverhandles(6),'position',datasets.alldata{udata.view.dataset}(idx,[xcol ycol zcol])+[xoff*xpix (yoff+s*0.75)*ypix (zoff+s*0.75)*zpix])

if handles.rowlabelcolumn{d}==0
    set(udata.explore.mouseoverhandles(2:end),'visible','on','string',strtrim(sprintf('%8.0f',idx)));
else
    switch handles.datatype{d}{handles.rowlabelcolumn}
        case 'string'
            set(udata.explore.mouseoverhandles(2:end),'visible','on','string','name');
        otherwise
            set(udata.explore.mouseoverhandles(2:end),'visible','on','string','notstring');
    end
end

if udata.view.c>0 && udata.format.colorbar
    %make mouseover pointers:
    
    legdata=get(handles.fakerax(ai),'userdata');
    aaa=findobj(legdata,'tag','Colorbar');
    pos=get(aaa,'position');
    ylim=get(aaa,'ylim');
    xlim=get(aaa,'xlim');
    
    clim=[min(datasets.alldata{d}(:,udata.view.c)) max(datasets.alldata{d}(:,udata.view.c))];
        
    %determine current c value:
    thisvalue=datasets.alldata{d}(idx,udata.view.c);
    thiscoord=interp1(clim,ylim,thisvalue);
    pixels=pos(3)./(xlim(2)-xlim(1)); %pixels per unit
    
    %make triangle patch at this value:
    set(udata.explore.cbarmouseovervalue,'ydata',[thiscoord-1 thiscoord+1  thiscoord],'visible','on');
    set(udata.explore.cbarmouseovertext,'position',[xlim(2)+3/pixels,thiscoord],'visible','on','string',sprintf('%5.5g',thisvalue));
end
