function boxselectscattermatrix(src,ev) %#ok<INUSD> %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
handles=guidata(src);
datasets=raveguidata(src,'datasets');
ai=get(src,'userdata'); %ai is userdata of subax.
udata=get(handles.fakeax(ai),'userdata');

clicked=get(src,'currentpoint');

xclick=clicked(1,1,1);
yclick=clicked(1,2,1);
handles.temp.startx=xclick;
handles.temp.starty=yclick;

handles.temp.selection=rectangle('position',[xclick yclick eps(xclick) eps(yclick)],'linewidth',1,'edgecolor',[1 .5 0],...
    'parent',src,'hittest','off','buttondownfcn','','facecolor','none','clipping','on');
%maindata=findobj(handles.activesubgraph,'tag','main');
%set(maindata,'visible','off');

handles.temp.selected=findobj(src,'tag','selected');
handles.temp.main=findobj(src,'tag','main');
% handles.temp.xdata=get(maindata,'xdata');
% handles.temp.ydata=get(maindata,'ydata');


switch udata.view.layout
    case {'square';'upper';'lower'}
        handles.temp.xdata=datasets.alldata{udata.view.dataset}(:,udata.view.x);
        handles.temp.ydata=datasets.alldata{udata.view.dataset}(:,udata.view.x);
    otherwise
        handles.temp.xdata=datasets.alldata{udata.view.dataset}(:,udata.view.x);
        handles.temp.ydata=datasets.alldata{udata.view.dataset}(:,udata.view.y);
end

set(handles.temp.selected,'userdata',false(size(handles.isselected{udata.view.dataset}{1},1),1));

%maintain manual/auto sizing:
%handles.temp.axesmode=get(handles.activegraph,'xlimmode');
%set(src,'xlimmode','manual','ylimmode','manual');

%allow dragging
set(handles.fig,'WindowButtonMotionFcn',@ravesizeselection);
set(handles.fig,'WindowButtonUpFcn',@ravesizeselectiondone);
set(handles.fig,'windowbuttondownfcn',[]);

guidata(src,handles);

function ravesizeselection(src,eventdata) %#ok<INUSD>
handles=guidata(src);
ai=get(gca,'userdata');
udata=get(handles.fakeax(ai),'userdata');

%if in pointselect mode, dont allow sizing, just go straight to buttonupfcn.
maindata=findobj(gca,'tag','main');
if ~isempty(get(maindata(1),'buttondownfcn'))
    if strcmp(func2str(get(maindata(1),'buttondownfcn')),'pointselect')
        return
    end
end

finish=get(gca,'currentpoint');
starty=handles.temp.starty;
startx=handles.temp.startx;
endx=finish(1,1,1);
endy=finish(1,2,1);

pos1=min(startx,endx);
pos3=max(startx,endx)-pos1;
pos2=min(starty,endy);
pos4=max(starty,endy)-pos2;

try %#ok<TRYNC>
    set(handles.temp.selection,'position',[pos1 pos2 pos3 pos4]);
end
%determine which points are in this rectangle:

[r,c]=find(handles.subax{ai}==gca);

try
    inpoints=raveinsidepoly(handles.temp.xdata(:,c),handles.temp.ydata(:,r),[pos1 pos1 pos1+pos3 pos1+pos3],[pos2 pos2+pos4 pos2+pos4 pos2]);
catch
    inpoints=inpolygon(handles.temp.xdata(:,c),handles.temp.ydata(:,r),[pos1 pos1 pos1+pos3 pos1+pos3],[pos2 pos2+pos4 pos2+pos4 pos2]);
end


unpoints=false(size(handles.temp.xdata,1),1);
unpoints(inpoints)=true;

nothidden=handles.isvisible{udata.view.dataset}{udata.view.analysis};

inpoints=unpoints & nothidden;

if ~handles.prefs.filteredselectable
    inpoints = inpoints & ~handles.isfiltered{udata.view.dataset}{udata.view.analysis};
end

if strcmp(get(handles.fig,'currentmodifier'),'shift')
    inpoints = handles.isselected{udata.view.dataset}{udata.view.analysis}|inpoints;
elseif strcmp(get(handles.fig,'currentmodifier'),'alt')
    lastselected=handles.isselected{udata.view.dataset}{udata.view.analysis};
    lastselected(inpoints)=false;
    inpoints= lastselected;
elseif strcmp(get(handles.fig,'currentmodifier'),'control')
    lastselected=handles.isselected{udata.view.dataset}{udata.view.analysis};
    inpoints=inpoints & lastselected;    
end


set(handles.infobar,'string',[strtrim(sprintf('%12.0f',sum(inpoints))) ' points selected'])

if ~any(inpoints)
    set(handles.temp.selected,'visible','off','userdata',false(size(handles.temp.xdata,1),1))
else
    %need to set all data properties so dimensions are correct.
    set(handles.temp.selected,'xdata',handles.temp.xdata(inpoints,c),'ydata',handles.temp.ydata(inpoints,r),...
        'visible','on','userdata',inpoints);
end


function ravesizeselectiondone(src,eventdata) %#ok<INUSD>
handles=guidata(src);
ai=get(gca,'userdata');
udata=get(handles.fakeax(ai),'userdata');
%stop dragging
set(handles.fig,'WindowButtonMotionFcn',@ravedefaultwindowbuttonmotionfcn);
set(handles.fig,'WindowButtonUpFcn',[]);

delete(handles.temp.selection);

%store indices of selected points.
inpoints=get(handles.temp.selected,'userdata');


set(handles.infobar,'string',[strtrim(sprintf('%12.0f',sum(inpoints))) ' points selected'])

handles.isselected{udata.view.dataset}{udata.view.analysis}=inpoints;
set(handles.fakeax(ai),'userdata',udata);

%update other scatters:
for r=1:size(handles.subax{ai},1)
    for c=1:size(handles.subax{ai},2)
        %if r==c;continue;end
        selected=findobj(handles.subax{ai}(r,c),'tag','selected');
        set(selected,'xdata',handles.temp.xdata(inpoints,c),'ydata',handles.temp.ydata(inpoints,r),'visible','on','userdata',inpoints);     

    end
end

%update other graphs:
raveupdateanalysis(src,handles,'isselected',[],udata.view.dataset,udata.view.analysis);

