function handles=raveupdatescattermatrixrowcolors(src,ev,handles)
%
% RAVE Rapid Analysis and Visualization Environment
% Copyright (C) 2010 Georgia Tech Research Corporation
% ALL RIGHTS RESERVED
%
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU General Public License
% as published by the Free Software Foundation; version 2
% of the License.
%
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
%handles=guidata(src);

%raveresizeaxes(src,[],handles.activeindex) %make appropriate margins for this graph type.

%get format inputs:
datasets=raveguidata(handles.fig,'datasets');
udata=get(handles.fakeax(handles.activeindex),'userdata');

if udata.view.c~=0;return;end

%inputs=varargin{3};

% pscales=udata.view.pscale;
% gscales=udata.view.gscale;
a=udata.view.analysis;
d=udata.view.dataset; %data set index


xcol=udata.view.x;

if strcmp(udata.view.layout,'square')
    ycol=xcol;
else
    ycol=udata.view.y;
end


selectedsize=udata.format.markersize;
        
        
%maintain hidden points:
isselected=handles.isselected{d}{a};
nothidden=logical(handles.isvisible{d}{a});
isfiltered=handles.isfiltered{d}{a};

%get data
xdata=datasets.alldata{d}(:,xcol);
ydata=datasets.alldata{d}(:,ycol);

rows=numel(ycol);
cols=numel(xcol);

%format for fillstyle:
fillstyle=udata.format.markerfill;

thecolors=handles.prefs.rowcolors;
if fillstyle==1
    facecolors=['none';'none';'none';'none';'none';'none';'none';'none';'none';'none'];
    edgecolors=thecolors;
elseif fillstyle==2
    edgecolors=['none';'none';'none';'none';'none';'none';'none';'none';'none';'none'];
    facecolors=thecolors;
else %fillstyle=3
    edgecolors=zeros(10,3);
    facecolors=thecolors;
end

%override for dots:
if strcmp(udata.format.marker,'.') || strcmp(udata.format.marker,'+') || strcmp(udata.format.marker,'*')
    %  pvpairs={'markerfacecolor','none','markeredgecolor','flat'};
    facecolors=['none';'none';'none';'none';'none';'none';'none';'none';'none';'none'];
    edgecolors=thecolors;
end

%initialize handles
main=zeros(rows,cols,10);
selected=zeros(rows,cols);


ax=handles.subax{handles.activeindex};




%set up grid of axes.
for r=1:1:numel(ycol)
    for c=1:1:numel(xcol)
        
        if strcmp(udata.view.layout,'square') && r==c
            continue
        end
        
        % delete(get(ax(r,c),'children'));
        delete(squeeze(udata.view.mainhandles(r,c,:))); %amazingly, delete cannot handle a 3d matrix.
        delete(udata.view.selectedhandles(r,c));
        
        rowcolors=handles.rowcolors{d}{a};
        %main data series:
        
        for s=1:10;
            if any(rowcolors==s & nothidden & ~isfiltered)
                main(r,c,s)=line(xdata(rowcolors==s & nothidden & ~isfiltered,c),ydata(rowcolors==s & nothidden & ~isfiltered,r),'marker',udata.format.marker,...
                    'markersize',udata.format.markersize,'markerfacecolor',facecolors(s,:),'markeredgecolor',edgecolors(s,:),'hittest','off',...
                    'tag','main','userdata',s,'linestyle','none','buttondownfcn',@pointselectscattermatrix,'parent',ax(r,c));
            elseif ~isempty(xdata)
                main(r,c,s)=line(xdata(1,c),ydata(1,r),'marker',udata.format.marker,'markersize',udata.format.markersize,...
                    'markerfacecolor',facecolors(s,:),'markeredgecolor',edgecolors(s,:),'hittest','off',...
                    'tag','main','userdata',s,'visible','off','linestyle','none','buttondownfcn',@pointselectscattermatrix,'parent',ax(r,c));
            else
                main(r,c,s)=nan;
            end
        end

        
        %selected data series:
        if ~isempty(xdata) && any(nothidden & isselected)
            selected(r,c) = line(xdata(nothidden & isselected,c),ydata(nothidden & isselected,r),'marker',udata.format.marker,...
                'markerfacecolor','none','markeredgecolor',handles.colors.selectionhighlight,'linestyle','none',...
                'visible','on','markersize',selectedsize,'hittest','off',...
                'tag','selected','userdata',isselected,'linewidth',max(1,handles.prefs.selectionthickness-1),'parent',ax(r,c));
        elseif ~isempty(xdata)
            selected(r,c) = line(xdata(1,c),ydata(1,r),'marker',udata.format.marker,...
                'markerfacecolor','none','markeredgecolor',handles.colors.selectionhighlight,'linestyle','none',...
                'visible','off','markersize',selectedsize,'hittest','off',...
                'tag','selected','userdata',false(length(xdata(:,c)),1),'linewidth',max(1,handles.prefs.selectionthickness-1),'parent',ax(r,c));
        else
            selected(r,c)=nan;
        end
    end
end

udata.view.mainhandles=main;
udata.view.selectedhandles=selected;

set(handles.fakeax(handles.activeindex),'userdata',udata);

