function pointselectdensity(src,ev)
handles=guidata(src);
datasets=raveguidata(handles.fig,'datasets');

if ~strcmp(handles.selectionmode,'point');return;end
set(handles.infobar,'string','Shift+Click to add points to current selection, Alt+Click to remove from selection');
%determine which point was clicked:
handles=guidata(src);

ai=find(handles.allgraphs==src);
udata=get(handles.fakeax(ai),'userdata');

d=udata.view.dataset;
a=udata.view.analysis;

handles.temp.selected=findobj(handles.allgraphs(ai),'tag','selected');
clicked=get(handles.allgraphs(ai),'currentpoint');

xclick=clicked(1,1,1);
yclick=clicked(1,2,1);

%get data
xcol=udata.view.x;
ycol=udata.view.y;

x=datasets.alldata{d}(:,xcol);
y=datasets.alldata{d}(:,ycol);

isselected=handles.isselected{d}{a};
nothidden=handles.isvisible{d}{a};
isfiltered=handles.isfiltered{d}{a};

%Normalize Data:
if isempty(udata.format.xlim);
    minx=min(x);
    maxx=max(x);
else
    minx=udata.format.xlim(1);
    maxx=udata.format.xlim(2);
end

if isempty(udata.format.ylim);
    miny=min(y);
    maxy=max(y);
else
    miny=udata.format.ylim(1);
    maxy=udata.format.ylim(2);
end

rangex=maxx-minx;
rangey=maxy-miny;

%normalize data before using inpolygon:
xclick=xclick-minx;
xclick=xclick./rangex;

yclick=yclick-miny;
yclick=yclick./rangey;

%% generate grid:
% For hexagons....
% Generate hexagonal grid

switch udata.view.gridshape
    case 'hexagon'

%get axes pixel size:
nx=udata.view.nx;
ny=udata.view.ny;

X=repmat(linspace(0,1,nx),ny,1);

Y=linspace(0,1,2*ny);
Y=reshape(Y,2,[])';

if rem(nx,2)==0 %nx is even
    Y=repmat(Y,1,nx/2);
else
    Y=repmat(Y,1,(nx-1)/2+1);
end

rx=diff(X(1,1:2))*(2/3);
ry=diff(Y(1:2,1))/sqrt(3);

X=X(:);
Y=Y(:);

thetas=[0 60 120 180 240 300]*pi/180;


inpoints=false(size(handles.isselected{udata.view.dataset}{udata.view.analysis}));

for c=1:numel(X)
    xhex=rx*cos(thetas)+X(c);
    yhex=ry*sin(thetas)+Y(c);
    
    try
        inhere=raveinsidepoly(xclick,yclick,xhex,yhex);
    catch %#ok<CTCH> %when mex is incompatible...
        inhere=inpolygon(xclick,yclick,xhex,yhex);
    end
    
    if inhere
        inpoints = udata.view.inhere(:,c);
    end
    
end

end

inrows=~handles.isfiltered{d}{a} & handles.isvisible{d}{a};
inpoints=inpoints & inrows;

if strcmp(get(handles.fig,'currentmodifier'),'shift')
    inpoints=handles.isselected{d}{a} | inpoints;
elseif strcmp(get(handles.fig,'currentmodifier'),'alt')
    lastselected=handles.isselected{d}{a};
    lastselected(inpoints)=false;
    inpoints=lastselected;
end

handles.isselected{d}{a}=inpoints;

%update other graphs:
handles=raveupdateanalysis(src,handles,'isselected',[],d,a);

if handles.prefs.setxdialswhensingleselected && sum(inpoints)==1
    handles.xdials{d}{a}=datasets.alldata{udata.view.dataset}(inpoints,:);
    raveupdateanalysis(src,handles,'xdials',[],d,a);
end







