function boxselectparallelcoords(src,ev) 
handles=guidata(src);
ai=find(handles.fakerax==gca | handles.allgraphs==gca);
src=handles.allgraphs(ai);
udata=get(handles.fakeax(ai),'userdata');

clicked=get(gca,'currentpoint');

xclick=clicked(1,1,1);
yclick=clicked(1,2,1);
handles.temp.startx=xclick;
handles.temp.starty=yclick;

handles.temp.selection=rectangle('position',[xclick yclick eps(xclick) eps(yclick)],'linewidth',1,'edgecolor',[1 .5 0],...
    'parent',src,'hittest','off','buttondownfcn','','facecolor','none','clipping','on');
handles.temp.wasselected=handles.isselected{udata.view.dataset}{udata.view.analysis};

set(handles.temp.selection,'userdata',false(size(handles.isselected{udata.view.dataset}{udata.view.analysis})));

%maintain manual/auto sizing:
handles.temp.axesmode=get(gca,'xlimmode');
set(src,'xlimmode','manual','ylimmode','manual');

%allow dragging
set(handles.fig,'WindowButtonMotionFcn',@ravesizeselection);
set(handles.fig,'WindowButtonUpFcn',@ravesizeselectiondone);
set(handles.fig,'windowbuttondownfcn',[]);

guidata(handles.fig,handles);

function ravesizeselection(src,eventdata) %#ok<INUSD>
handles=guidata(src); 
ai=find(handles.fakerax==gca | handles.allgraphs==gca);
udata=get(handles.fakeax(ai),'userdata');


set(udata.explore.mouseoverhandles,'visible','off');
set(udata.explore.cbarmouseovertext,'visible','off');
set(udata.explore.cbarmouseovervalue,'visible','off');

finish=get(gca,'currentpoint');
starty=handles.temp.starty;
startx=handles.temp.startx;
endx=finish(1,1,1);
endy=finish(1,2,1);

pos1=min(startx,endx);
pos3=max(startx,endx)-pos1;
pos2=min(starty,endy);
pos4=max(starty,endy)-pos2;

try %#ok<TRYNC>
    set(handles.temp.selection,'position',[pos1 pos2 pos3 pos4]);
end


%determine which axes are in this rectangle:

xcoords=linspace(0,1,numel(udata.view.x));
invars=find(xcoords>=pos1 & xcoords<=(pos1+pos3));
alllinedata=cell2mat(get(udata.view.hiddenhandles,'ydata'));
theseinpoints=false(size(alllinedata,1));


for g=1:numel(invars)
    newkeeperz = alllinedata(:,invars(g))>=pos2 & alllinedata(:,invars(g))<=(pos2+pos4);
    theseinpoints(newkeeperz)=true;
end

inpoints=false(size(handles.isselected{udata.view.dataset}{udata.view.analysis}));
inpoints(udata.view.maxlineindex(theseinpoints))=true;


if strcmp(get(handles.fig,'currentmodifier'),'shift')
    inpoints = handles.temp.wasselected | inpoints;
elseif strcmp(get(handles.fig,'currentmodifier'),'alt')
    lastselected=handles.temp.wasselected;
    lastselected(inpoints)=false;
    inpoints= lastselected;
elseif strcmp(get(handles.fig,'currentmodifier'),'control')
    %set(handles.infobar,'string','Ctrl+Selection is not yet supported for parallel coordinates graphs.')
    %return
    inpoints= handles.temp.wasselected & inpoints;
end

inpoints=inpoints & handles.isvisible{udata.view.dataset}{udata.view.analysis};

if ~handles.prefs.filteredselectable
    inpoints = inpoints & ~handles.isfiltered{udata.view.dataset}{udata.view.analysis};
end

set(handles.infobar,'string',[strtrim(sprintf('%12.0f',sum(inpoints))) ' points selected'])

handles.isselected{udata.view.dataset}{udata.view.analysis}=inpoints;

raveupdateanalysis(src,handles,'isselected',[],udata.view.dataset,udata.view.analysis);

set(handles.temp.selection,'userdata',inpoints)


function ravesizeselectiondone(src,eventdata) %#ok<INUSD>
handles=guidata(src);
ai=find(handles.fakerax==gca | handles.allgraphs==gca);
udata=get(handles.fakeax(ai),'userdata');
%stop dragging
set(handles.fig,'WindowButtonMotionFcn',@ravedefaultwindowbuttonmotionfcn);
set(handles.fig,'WindowButtonUpFcn',[]);
set(gca,'xlimmode',handles.temp.axesmode,'ylimmode',handles.temp.axesmode)

set(handles.infobar,'string','');

inpoints=get(handles.temp.selection,'userdata');
delete(handles.temp.selection);

%store indices of selected points.
handles.isselected{udata.view.dataset}{udata.view.analysis}=inpoints;

%update other graphs:
raveupdateanalysis(src,handles,'isselected',[],udata.view.dataset,udata.view.analysis);

