function handles=raveupdateparallelcoordsdatachanged(src,ev,handles,thesevars)
%
% RAVE Rapid Analysis and Visualization Environment
% Copyright (C) 2010 Georgia Tech Research Corporation
% ALL RIGHTS RESERVED
% 
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU General Public License
% as published by the Free Software Foundation; version 2
% of the License.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.

datasets=raveguidata(handles.fig,'datasets');
udata=get(handles.fakeax(handles.activeindex),'userdata');

xcol=udata.view.x;
%ycols=udata.view.y;
ccol=udata.view.c;
% pscales=udata.view.pscale;
% gscales=udata.view.gscale;
a=udata.view.analysis;
d=udata.view.dataset;

%get data
x=datasets.alldata{d}(:,xcol);
%normalize xdata:
data1=bsxfun(@minus,x,handles.minlimit{d}{a}(xcol));
data2=bsxfun(@rdivide,data1,(handles.maxlimit{d}{a}(xcol)-handles.minlimit{d}{a}(xcol)));
data2(isnan(data2))=.5;
x=data2;

%maintain hidden points:
nothidden=handles.isvisible{udata.view.dataset}{udata.view.analysis};

%filter based on max rows
if udata.view.usemaxlines
   index=udata.view.maxlineindex;
else    
    index=1:size(x,1);    
end

nothidden=nothidden(index);
x=x(index,:);

%% get constantvalues:
% if constcol is blank, use a column of ones of same length as xdata.
% Otherwise use the actual data from the constcol column.


%append a column of ones on the end for when constcol="none selected"...
%might need to move this line somewhere else in code.

 [c,cdata]=ravemakerowcdata(handles,datasets,udata,ccol,udata.format.lcmap,index);

%if any x is outside 0-1, need to rescale data, and update ranges:

%remove hidden rows:
x=x(nothidden,:);
cdata=cdata(nothidden,:);

%% make data:
x=num2cell(x,2);
if ccol~=0
    cdata=num2cell(cdata,2);
    set(udata.view.hiddenhandles,{'ydata'},x);
    set(udata.view.mainhandles,{'ydata'},x,{'color'},cdata,{'userdata'},cdata);
    set(udata.view.selectedhandles,{'ydata'},x);
    
else
    set(udata.view.hiddenhandles,{'ydata'},x);
    set(udata.view.mainhandles,{'ydata'},x);
    set(udata.view.selectedhandles,{'ydata'},x);
end

parallelcoordsapplyfilter(src,[],handles.activeindex,handles);




