function handles=raveupdateparallelcoordsisfiltered(src,ev,handles)
%
% RAVE Rapid Analysis and Visualization Environment
% Copyright (C) 2010 Georgia Tech Research Corporation
% ALL RIGHTS RESERVED
% 
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU General Public License
% as published by the Free Software Foundation; version 2
% of the License.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
%handles=guidata(src);
getudata;
ai=handles.activeindex;

if numel(udata.view.x)==1;return;end %no need to update because graph is invalid.


d=udata.view.dataset;
a=udata.view.analysis;

minvalz=handles.minfilter{d}{a};
maxvalz=handles.maxfilter{d}{a};

%convert to 0-1 range:
minz=udata.view.varmins;
rangez=udata.view.varranges;
maxz=minz+rangez;

%if columns have been added to the data set since this graph was created,
%need to update 
newminz=(minvalz-minz)./(rangez);
newmaxz=(maxvalz-minz)./(rangez);

newminz(isnan(newminz)|isinf(newminz))=0;
newmaxz(isnan(newmaxz)|isinf(newmaxz))=1;

mindrags=udata.view.mindraggers;
maxdrags=udata.view.maxdraggers;

%update draggers:
set(mindrags(:,1),{'ydata'},num2cell(newminz(udata.view.x))');
set(maxdrags(:,1),{'ydata'},num2cell(newmaxz(udata.view.x))');
set(mindrags(:,2),{'ydata'},num2cell(newminz(udata.view.x))');
set(maxdrags(:,2),{'ydata'},num2cell(newmaxz(udata.view.x))');

%update text labels:
% posses=cell2mat(get(udata.view.mintexts,'pos'));
xposses=linspace(0,1,numel(udata.view.x));
minposses=[xposses' newminz(udata.view.x)'];
minposses=num2cell(minposses,2);
maxposses=[xposses' newmaxz(udata.view.x)'];

maxposses=num2cell(maxposses,2);


set(udata.view.mintexts,{'position'},minposses);
set(udata.view.maxtexts,{'position'},maxposses);


minstr=cell(numel(udata.view.x),1);
maxstr=cell(numel(udata.view.x),1);
for g=1:numel(udata.view.x)
    minstr{g}=['',raveformatnumber(minvalz(udata.view.x(g)))];
    maxstr{g}=['',raveformatnumber(maxvalz(udata.view.x(g)))];
end

set(udata.view.mintexts,{'string'},minstr);

set(udata.view.maxtexts,{'string'},maxstr);


%update real number values:
udata.view.lowfilter=handles.minfilter{d}{a};
udata.view.highfilter=handles.maxfilter{d}{a};

setudata;

parallelcoordsapplyfilter(handles.fig,[],ai,handles);




