function ravecreateblank3D(src,ev)
%
% RAVE Rapid Analysis and Visualization Environment
% Copyright (C) 2010 Georgia Tech Research Corporation
% ALL RIGHTS RESERVED
%
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU General Public License
% as published by the Free Software Foundation; version 2
% of the License.
%
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.

handles=guidata(src);
udata=get(handles.fakeax(handles.activeindex),'userdata');

%set([handles.fakeax(handles.activeindex) handles.fakerax(handles.activeindex)],'vis','off');

%inputs=varargin{3};
targetaxes=handles.activegraph;

%clear existing graph
cla(targetaxes);
delete(findall(targetaxes,'type','text')); %delete hidden tick labels
% legend(targetaxes,'off');

set(targetaxes,'xlimmode','auto','ylimmode','auto','zlimmode','auto');
set(targetaxes,'xtickmode','auto','ytickmode','auto','ztickmode','auto');
set(targetaxes,'xticklabelmode','auto','yticklabelmode','auto','zticklabelmode','auto');

if udata.format.boxon
    set([targetaxes handles.fakeax(handles.activeindex) handles.fakerax(handles.activeindex)],'box','on')
else
    set([targetaxes handles.fakeax(handles.activeindex) handles.fakerax(handles.activeindex)],'box','off')
end

set(targetaxes,'climmode','manual','clim',[1 size(get(handles.fig,'colormap'),1)]);

%set buttondownfcns:
set(targetaxes,'hittest','on','buttondownfcn',@buttondownfcnblank3D)
%ravesetselectionmodescatter3D(handles.fig,handles.activeindex);

%Make graph %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
fcn=udata.view.function;
if ~isempty(fcn)
   fcn=str2func(fcn);
   fcn(handles.fig,[]);
   handles=guidata(handles.fig);
end


%Synchronize axes limits:
set(handles.fakerax(handles.activeindex),'xlim',get(targetaxes,'xlim'),'ylim',get(targetaxes,'ylim'),'zlim',get(targetaxes,'zlim'))
set(handles.fakeax(handles.activeindex),'xlim',get(targetaxes,'xlim'),'ylim',get(targetaxes,'ylim'),'zlim',get(targetaxes,'zlim'))
set(targetaxes,'xlimmode','manual','ylimmode','manual','zlimmode','manual');

%set axes label fonts:
set(get(targetaxes,'XLabel'),'fontsize',handles.fonts.graphsize,...
    'fontweight','normal','interpreter','none','fontname',handles.fonts.graph)
set(get(targetaxes,'YLabel'),...
    'fontsize',handles.fonts.graphsize,'fontweight','normal','interpreter','none','fontname',handles.fonts.graph)
set(get(targetaxes,'ZLabel'),...
    'fontsize',handles.fonts.graphsize,'fontweight','normal','interpreter','none','fontname',handles.fonts.graph)

% set(get(handles.fakerax(handles.activeindex),'XLabel'),'String',handles.allnames{d}{xcol},'fontsize',labelsize,...
%     'fontweight',fweight,'interpreter','none','fontname',handles.fonts.graph)
% set(get(handles.fakerax(handles.activeindex),'YLabel'),'String',handles.allnames{d}{ycol},...
%     'fontsize',labelsize,'fontweight',fweight,'interpreter','none','fontname',handles.fonts.graph)
% set(get(handles.fakerax(handles.activeindex),'ZLabel'),'String',handles.allnames{d}{zcol},...
%     'fontsize',labelsize,'fontweight',fweight,'interpreter','none','fontname',handles.fonts.graph)
% 
% set(get(handles.fakeax(handles.activeindex),'XLabel'),'String',handles.allnames{d}{xcol},'fontsize',labelsize,...
%     'fontweight',fweight,'interpreter','none','fontname','arial')
% set(get(handles.fakeax(handles.activeindex),'YLabel'),'String',handles.allnames{d}{ycol},...
%     'fontsize',labelsize,'fontweight',fweight,'interpreter','none','fontname',handles.fonts.graph)
% set(get(handles.fakeax(handles.activeindex),'ZLabel'),'String',handles.allnames{d}{zcol},...
%     'fontsize',labelsize,'fontweight',fweight,'interpreter','none','fontname',handles.fonts.graph)

%resize axes so axes labels/ticks fit inside the bounding box.
targetindex=find(handles.allgraphs==targetaxes);

%adjust gridlines to match settings:
ravesetgrid3D;



%make all axes have same limits
Q=[handles.fakerax(handles.activeindex) handles.fakeax(handles.activeindex)];
set(Q,'xlim',get(targetaxes,'xlim'),'ylim',get(targetaxes,'ylim'),'zlim',get(targetaxes,'zlim'),...
    'xtickmode','manual','xtick',get(targetaxes,'xtick'),...
    'ytickmode','manual','ytick',get(targetaxes,'ytick'),...
    'ztickmode','manual','ztick',get(targetaxes,'ztick'));
set(Q,...
    'xticklabel',get(targetaxes,'xticklabel'),...
    'yticklabel',get(targetaxes,'yticklabel'),...
    'zticklabel',get(targetaxes,'zticklabel'));
set(Q,'xlim',get(targetaxes,'xlim'),'ylim',get(targetaxes,'ylim'),'zlim',get(targetaxes,'zlim'))
set(Q,'ticklength',[0 0]);

%update handles
guidata(handles.fig,handles)


%if there is a colorbar, fix it:
%NOTE: shrinking graph to make room for colorbar is handled by raveresizeaxes.

ravemakecolorbar(handles.fig,[]);

%fix rotation if necessary:
view(handles.activegraph,udata.view.az,udata.view.el)
view(handles.fakeax(handles.activeindex),udata.view.az,udata.view.el)
view(handles.fakerax(handles.activeindex),udata.view.az,udata.view.el)

raveresizeaxes(src,[],targetindex)
clear ravearrangeobjects



