function udata=raveinitializeudatatableallpoints(src,ev)
handles=guidata(src);

udata = raveinitializeudatastandard(src,ev);

datasets=raveguidata(handles.fig,'datasets');

udata.view.maxpos=get(handles.fakerax(handles.activeindex),'position');

numrows=size(handles.isselected{1}{1},1);
rownumbers=1:numrows;
%convert data into a cell array of strings:
rownumbers=num2cell(rownumbers);
for r=1:numrows
    rownumbers{r}=sprintf('%-6.0f',rownumbers{r});
end



udata.format.fontname='Arial';
udata.format.fontsize=10;
udata.format.fontstyle=0;

%Get font info for calculating column widths:
[style,javastyle]=ravegetfontstyle(0);
axiscanvas=ravegetaxiscanvas(handles.fig);
FontMetrics=RaveFontMetrics(axiscanvas.getGraphics,udata.format.fontname,ceil(udata.format.fontsize*4/3),javastyle);
    
[w,fontheight]=ravecalculatestringlengthfast(handles.allnames{1},FontMetrics);
w=w(:)'+5;    
w(w<60)=60;

udata.view.x=1:numel(handles.allnames{1});
udata.view.allcolnames=handles.allnames{1};
udata.view.colnames=handles.allnames{1};
udata.view.allcolwidths=w;
udata.view.colwidths=w; %NOTE: length(colwidths)==numel(handles.allnames{d} at all times. Just index into it using xcol when creating tables.
udata.view.rowheight=ceil(fontheight);
udata.view.allrows=1:numrows;
udata.view.rowheadermode='1toN';
udata.view.rownames=rownumbers;
udata.view.data=datasets.alldata{1};
udata.view.headerheight=22;
udata.view.headerwidth=10+10*ceil(log10(numrows));
udata.view.tight=1;
udata.view.hscroll=[];
udata.view.vscroll=[];
udata.view.rowheader=[];
udata.view.colheader=[];
udata.view.texthandles=[];
udata.view.showrows=[true true true false];
udata.view.rowlimit=1000;
udata.view.sortascending=true;

udata.format.colheadercolor=[222 234 241]./255;
udata.format.rowheadercolor=[222 234 241]./255;
udata.format.gridlinecolor=[.7 .7 .7];
udata.format.userowcolors=0;
udata.format.titleaxes=[];
udata.format.allowselection=1;

udata.format.textcolor=[0 0 0];
udata.format.unselectedcolor=[1 1 1];
udata.format.hiddencolor=[200 200 200]/255;
udata.format.selectedcolor=[154 202 250]/255;
udata.format.filteredcolor=[200 200 200]/255;
udata.format.rowheight=[]; %for future use

udata.explore.method={};
udata.explore.extrainset=[0 0 0 0];
