function viewtabtablesinglepoint(src,eventdata) %#ok<INUSD>
%
% RAVE Rapid Analysis and Visualization Environment
% Copyright (C) 2010 Georgia Tech Research Corporation
% ALL RIGHTS RESERVED
%
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU General Public License
% as published by the Free Software Foundation; version 2
% of the License.
%
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
%RAVE: creates uicontrols on the view tab for line graphs.

handles=guidata(src);

%move front tabs to front if necessary
% if handles.fronttabsfront==0 %swap fronttabs and backtabs
set(handles.fronttabaxes,'position',handles.fronttabposition)
set(handles.backtabaxes,'position',handles.backtabposition)
[x,y,v]=calculatetabprofile(handles.backtabprofile,.1,1,0); %#ok<NASGU>
set(handles.backtablines,'xdata',x,'ydata',y);
% end
% handles.fronttabsfront=1;

[x,y,v]=calculatetabprofile(handles.fronttabprofile,.1,2,1); %#ok<NASGU>
set(handles.fronttablines,'xdata',x,'ydata',y)

set(handles.infobar,'string','');

origin=get(handles.tabaxes,'position');

%% clear existing tab
%delete(handles.tabobjects)

%% get input info from graph:
udata=get(handles.fakeax(handles.activeindex),'userdata');
d=udata.view.dataset;
a=udata.view.analysis;

%% text headers
projecttext=text(.15-.10317,.95*1.0317-.0317,'Project','horizontalalignment','left','backgroundcolor',handles.colors.tabbg,...
    'parent',handles.tabaxes,'fontsize',handles.fonts.titlesize,'fontname',handles.fonts.title,'color',handles.colors.title);
dataseriestext=text(.15-.10317,.75*1.0317-.0317,'Data Series','horizontalalignment','left','backgroundcolor',handles.colors.tabbg,...
    'parent',handles.tabaxes,'fontsize',handles.fonts.titlesize,'fontname',handles.fonts.title,'color',handles.colors.title);

%% text labels
analysistext=text(.25-.10317,.920*1.0317-.0317,'Choose Parent Analysis:','horizontalalignment','left',...
    'backgroundcolor',handles.colors.tabbg,...
    'parent',handles.tabaxes,'fontsize',10,'fontname','arial','color',[0 0 0],'fontweight','bold','backgroundcolor','none');
datasettext=text(.25-.10317,.85*1.0317-.0317,'Choose a Data Set:','horizontalalignment','left',...
    'backgroundcolor',handles.colors.tabbg,...
    'parent',handles.tabaxes,'fontsize',10,'fontname','arial','color',[0 0 0],'fontweight','bold');

%% variable lists
analysismenu=uicontrol('position',[origin(1)+55 origin(2)+535 180 30],...
    'style','popupmenu','string',handles.analysisnames,'callback',@analysismenu_callback,...
    'backgroundcolor',[1 1 1],'tag','analysismenu','value',a);
datasetmenu=uicontrol('position',[origin(1)+55 origin(2)+490 180 30],...
    'style','popupmenu','string',handles.datasetnames,'callback',@datasetmenu_callback,...
    'backgroundcolor',[1 1 1],'tag','datasetmenu','value',d);

%% options:

coltext=text(.25-.10317,.71,'Variables to Display:','horizontalalignment','left',...
    'backgroundcolor',handles.colors.tabbg,...
    'parent',handles.tabaxes,'fontsize',10,'fontname','arial','color',[0 0 0],'fontweight','bold');


yaxismenu=uicontrol('position',[origin(1)+55 origin(2)+230 180 210],...
    'style','listbox','string',handles.allnames{d},'callback',@yaxismenu_callback,...
    'backgroundcolor',[1 1 1],'tag','yaxismenu','value',udata.view.y,'max',100);

displaytext=text(.25-.10317,.35,'Display Mode:','horizontalalignment','left',...
    'backgroundcolor',handles.colors.tabbg,...
    'parent',handles.tabaxes,'fontsize',10,'fontname','arial','color',[0 0 0],'fontweight','bold');

currentpointcheck=uicontrol('position',[origin(1)+55 origin(2)+190 180 22],...
    'style','radio','string','Display "Current Point" values','callback',@currentpointcheck_callback,...
    'backgroundcolor',[1 1 1],'tag','currentpointcheck','value',udata.view.showcurrentpoint);

fixedpointcheck=uicontrol('position',[origin(1)+55 origin(2)+165 180 22],...
    'style','radio','string','Display values for row','callback',@fixedpointcheck_callback,...
    'backgroundcolor',[1 1 1],'tag','fixedpointcheck','value',~udata.view.showcurrentpoint);

fixedpointedit=uicontrol('position',[origin(1)+185 origin(2)+165 50 22],...
    'style','edit','string',handles.allnames{d},'callback',@fixedpointedit_callback,...
    'backgroundcolor',[1 1 1],'tag','fixedpointedit','string',num2str(udata.view.row));

%% group items and finish up
handles.tabobjects=[datasettext datasetmenu,...
    analysistext projecttext analysismenu dataseriestext coltext yaxismenu displaytext currentpointcheck fixedpointcheck ...
    fixedpointedit];

handles.activetab='view';

guidata(src,handles);


function datasetmenu_callback(src,ev)
handles=guidata(src);
udata=get(handles.fakeax(handles.activeindex),'userdata');
d=get(src,'value');
udata.view.dataset=d;
udata.view.x=1:numel(handles.allnames{d});
udata.view.s=0;
set(handles.fakeax(handles.activeindex),'userdata',udata)
raveupdatetablesinglepoint(src,ev);

function analysismenu_callback(src,ev)
handles=guidata(src);
udata=get(handles.fakeax(handles.activeindex),'userdata');
udata.view.analysis=get(src,'value');
set(handles.fakeax(handles.activeindex),'userdata',udata)
raveupdatetablesinglepoint(src,ev);

function yaxismenu_callback(src,ev)
handles=guidata(src);
udata=get(handles.fakeax(handles.activeindex),'userdata');
udata.view.y=get(src,'value');
set(handles.fakeax(handles.activeindex),'userdata',udata)
raveupdatetablesinglepoint(src,ev);


function currentpointcheck_callback(src,ev)
handles=guidata(src);
udata=get(handles.fakeax(handles.activeindex),'userdata');
fixedpointcheck=findobj(handles.tabobjects,'tag','fixedpointcheck');
set(fixedpointcheck,'value',0);
set(src,'value',1);
udata.view.showcurrentpoint=1;

set(handles.fakeax(handles.activeindex),'userdata',udata)
raveupdatetablesinglepoint(src,ev);

function fixedpointcheck_callback(src,ev)
handles=guidata(src);
udata=get(handles.fakeax(handles.activeindex),'userdata');
currentpointcheck=findobj(handles.tabobjects,'tag','currentpointcheck');
set(currentpointcheck,'value',0);
set(src,'value',1);
udata.view.showcurrentpoint=0;
set(handles.fakeax(handles.activeindex),'userdata',udata)
raveupdatetablesinglepoint(src,ev);

function fixedpointedit_callback(src,ev)
handles=guidata(src);
udata=get(handles.fakeax(handles.activeindex),'userdata');


val=round(str2double(get(src,'string')));

if isnan(val);val=1;end
if val>size(handles.isselected{udata.view.dataset}{1},1);val=size(handles.isselected{udata.view.dataset}{1},1);end
if val<1;val=1;end

set(src,'string',num2str(val));

udata.view.row=val;
set(handles.fakeax(handles.activeindex),'userdata',udata)
raveupdatetablesinglepoint(src,ev);
