//Return information about strings rendered in a particular font

import java.awt.*;
import java.awt.geom.*;
//import java.awt.event.*;
//import java.util.*;
//import java.util.List;

//import javax.swing.*;

public class RaveFontMetrics {
    protected Font font;
    protected Graphics gfx;
    protected FontMetrics metrics;
    
    
    
    public RaveFontMetrics(Graphics gfx, String fontname, int fontsize){
        Font font = new Font(fontname,java.awt.Font.PLAIN,fontsize);
        this.font = font;
        
        FontMetrics metrics = gfx.getFontMetrics(font);
        this.metrics=metrics;
    }
    
     public RaveFontMetrics(Graphics gfx, String fontname, int fontsize, int fontstyle){
        Font font = new Font(fontname,fontstyle,fontsize);
        this.font = font;
        
        FontMetrics metrics = gfx.getFontMetrics(font);
        this.metrics=metrics;
    }
    
     public Font getFont(){
         return this.font;
     }
     
     public double getWidth(String str){
         if (str != null) {
             Rectangle2D bounds = metrics.getStringBounds(str,this.gfx);
             return ((Rectangle2D.Float)bounds).getWidth();
         } else {
             return 0;
         }       
    }
    
    public double[] getWidth(String[] str){
        if (str != null) {
        double[] widths = new double[str.length];
        for (int i = 0; i < str.length; i++) {
            Rectangle2D bounds = metrics.getStringBounds(str[i],this.gfx);
            widths[i] = ((Rectangle2D.Float)bounds).getWidth();
        }
        return widths;
        } else {
            return new double[0];
        }
            
    }
    
    
    public double getHeight(String str){
        if (str != null) {
            Rectangle2D bounds = metrics.getStringBounds(str,this.gfx);
            return ((Rectangle2D.Float)bounds).getHeight();
        } else {
            return 0;
        }
    }
    
    public double getHeight(String[] str){
        if (str != null) {
        Rectangle2D bounds = metrics.getStringBounds(str[1],this.gfx);
        return ((Rectangle2D.Float)bounds).getHeight();
        } else {
            return 0; //note, return 0 here instead of empty since getHeight is always expected to return a scalar. 
        }
        
    }
    
    
}
