//The cell renderer used by the main table when the variable is "integer" or "logical" type.
import java.awt.*;
import java.awt.event.*;
import java.util.*;
import java.util.List;
import javax.swing.*;
import javax.swing.event.TableModelEvent;
import javax.swing.event.TableModelListener;
import javax.swing.table.*;
import javax.swing.border.*;
import java.text.DecimalFormat;
//import RaveTableModel;

public class RaveNoiseTableCellRenderer extends JLabel implements TableCellRenderer {
    protected Color defaultColor = new Color(255,255,255);
    protected Color shadedColor = new Color(179,179,179);
    protected Color filteredColor = new Color(204,204,204);
    protected Color selectedColor = new Color(154,202,250);
    protected Color selectedShadedColor = new Color(112,165,228);
    protected Color textColor = new Color(0,0,0);
    protected Color warnColor = new Color(200,200,200);
    private RaveTableSorter rtm;
    private Color backgroundColor;
    
    public Component getTableCellRendererComponent(JTable table, Object value,
    boolean isSelected, boolean hasFocus, int row, int column) {
        
        setText("Random");
        setOpaque(true);
        setBackground(defaultColor);
        setForeground(warnColor);
        
        this.rtm = (RaveTableSorter)table.getModel();
        int modelrow= this.rtm.modelIndex(row);
        boolean[] isRowShaded = this.rtm.getIsRowShaded();
        boolean[] isRowFiltered = this.rtm.getIsRowFiltered();
        
        if(isSelected && isRowShaded[modelrow]) {
            this.backgroundColor = selectedShadedColor;
        } else if(isSelected && isRowFiltered[modelrow]) {
            backgroundColor = selectedShadedColor;
        } else if(isRowShaded[modelrow]) {
            backgroundColor = shadedColor;
        } else if(isRowFiltered[modelrow]) {
            backgroundColor = filteredColor;
        } else if(isSelected) {
            backgroundColor = selectedColor;
        } else {
            backgroundColor = defaultColor;
        }
        
        setBackground(backgroundColor);
        setBorder(BorderFactory.createMatteBorder(0, 4, 0, 0, backgroundColor));
        
        return this;
    }
    
    public boolean isOpaque() {
        return true;
    }
    
    public void setBackgroundColor(Color newBackgroundColor) {
        defaultColor = newBackgroundColor;
    }
    
    public void setShadedColor(Color newShadedColor) {
        shadedColor = newShadedColor;
    }
    
    public void setSelectedColor(Color newSelectedColor) {
        selectedColor = newSelectedColor;
    }
    
    public void setFilteredColor(Color newFilteredColor) {
        filteredColor = newFilteredColor;
    }
    
    public void setSelectedShadedColor(Color newSelectedShadedColor) {
        selectedShadedColor = newSelectedShadedColor;
    }
    
    public void setTextColor(Color newTextColor) {
        textColor = newTextColor;
    }
    
    
    public Color getBackgroundColor() {
        return defaultColor;
    }
    
    public Color getShadedColor() {
        return shadedColor;
    }
    
    public Color getSelectedColor() {
        return selectedColor;
    }
    
    public Color getFilteredColor() {
        return filteredColor;
    }
    
    public Color getSelectedShadedColor() {
        return selectedShadedColor;
    }
    
    public Color getTextColor() {
        return textColor;
    }
    
    public void validate() {}
    public void revalidate() {}
    public void repaint(long tm, int x, int y, int width, int height) {}
    public void repaint (Rectangle r) {}
    protected void firePropertyChange(String propertyName, Object oldValue, Object newValue) {}
    public void firePropertyChange(String propertyName, boolean oldValue, boolean newValue) {}
    
}