/* A utility class to convert matlab arrays to a java Object[][] that can serve
 * as the input to a DefaultTableModel constructor. The purpose of this is to
 * avoid needing to convert numerical data to cell arrays in Matlab, which is slow
 * and uses a ton of memory. *
 */

import java.awt.*;

public class RaveTableModelDataPreparator {
    
   // private Object[][] dataObject;
    
    
    public RaveTableModelDataPreparator() {
    }
    
    public Object[][] getDataObject(double[][] numericalData, String[][] textData, char[] formatString) {
       Object[][] dataObject = new Object[numericalData.length][formatString.length];
        
        int n = 0; //counter for numerical columns
        int t = 0; //counter for text columns
        
        for (int j =0;j < formatString.length; j++) { //for each column...
            if (formatString[j]=='n') {
                //If this is a number, store the next column of numericalData
                for (int i =0;i < dataObject.length; i++) {
                    dataObject[i][j] = (Object) numericalData[i][n];
                }
                n++;
            } else {
                //Store the next column of textData
                for (int i =0;i < dataObject.length; i++) {
                    dataObject[i][j] = (Object) textData[i][t];
                }
                t++;
                
            }
        }
        
        return dataObject;
        
    }
    
  /*  public Object[][] getDataObject(){
        return dataObject;
    }
   */
}

