function ravecreatemaintable(src,ev)
%
% RAVE Rapid Analysis and Visualization Environment
% Copyright (C) 2011 Georgia Tech Research Corporation
% ALL RIGHTS RESERVED
% 
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU General Public License
% as published by the Free Software Foundation; version 2
% of the License.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.

handles=guidata(src);

%table dims:
left=30+315*handles.prefs.tabscale;
bottom=1;
height=handles.height-35;
width=handles.width-(30+315*handles.prefs.tabscale);

originalLnF = javax.swing.UIManager.getLookAndFeel;  %class
if ~handles.prefs.dontchangemylaf
    try %#ok<TRYNC>
        newLnF = 'com.sun.java.swing.plaf.nimbus.NimbusLookAndFeel';
  %      javax.swing.UIManager.setLookAndFeel(newLnF); %note, dont use nimbus l&f for tables since it has a bug that doesnt display grid lines
    end
end

data={'No Data Loaded'}; %the table data.

tableData=java.lang.String('No Data Loaded');
varnames={''};
rowData=java.lang.Integer(1);


%make main table model, and put it in a table:
dmodel=javax.swing.table.DefaultTableModel(tableData,varnames);
javaObjectEDT(dmodel);
jtable=javax.swing.JTable(dmodel);
javaObjectEDT(jtable);

%make row header model, and put it in a table:
rmodel=javax.swing.table.DefaultTableModel(rowData,{''});
javaObjectEDT(rmodel);
rowHeader=javax.swing.JTable(rmodel);
javaObjectEDT(rowHeader);

%not sure what this does, but i guess it's important...
jtable.setSelectionModel(rowHeader.getSelectionModel());

%some formatting...
rowHeader.setBackground(java.awt.Color.lightGray);
rowHeader.setColumnSelectionAllowed(false);
rowHeader.setCellSelectionEnabled(false);

%make the header the appropriate width:
headerWidth=25;
rhHeight=rowHeader.getPreferredSize.height;
rowHeader.setPreferredSize(java.awt.Dimension(headerWidth,rhHeight))
rowHeader.setSize(java.awt.Dimension(headerWidth,rhHeight))

%hide the column header of the row header:
rowHeader.getTableHeader.setVisible(false);

%put the row header in a viewport.
jv=javax.swing.JViewport;
javaObjectEDT(jv);
jv.setView(rowHeader);
jv.setPreferredSize(java.awt.Dimension(headerWidth,rhHeight));

%put the main table in a scroll pane, and append the row header:
jtable.setAutoResizeMode(jtable.AUTO_RESIZE_OFF);
jscroll=javax.swing.JScrollPane(jtable);
javaObjectEDT(jscroll);
jscroll.setRowHeader(jv);
jscroll.setCorner(javax.swing.ScrollPaneConstants.UPPER_LEFT_CORNER, rowHeader.getTableHeader());

%place it all in figure:
[jscroll mtable]=javacomponent(jscroll,[left bottom width height],handles.fig);

%jtable=handle(jtable,'callbackproperties');

jtable.setAutoResizeMode(javax.swing.JTable.AUTO_RESIZE_OFF); %no auto resize (show horizontal scroll)
g=handles.colors.maintable.grid;
jtable.setGridColor(java.awt.Color(g(1),g(2),g(3)));
jtable.setBackground(java.awt.Color(1,1,1));
jtable.setColumnSelectionAllowed(true);
jtable.setRowSelectionAllowed(true);

%save header renderer for future use:
cm=rowHeader.getColumnModel;
c=cm.getColumn(0);
handles.maintable.defaultRowHeaderRenderer = c.getCellRenderer;

%fix blinking: 
jtable.setDoubleBuffered(true);
jscroll.setDoubleBuffered(true);

set(mtable,'backgroundcolor',[1 1 1]);
handles.maintable.handle=mtable;
handles.maintable.jtable=jtable;
handles.maintable.jscroll=jscroll;
guidata(handles.fig,handles);



