function ravemaintabledecidecolumn(src,ev)

handles=guidata(src);
datasets=raveguidata(handles.fig,'datasets');

MouseEvent=get(0,'userdata');

d=handles.maintable.d;

c=handles.maintable.jtable.getColumnModel.getColumnIndexAtX(MouseEvent.getX);
col=handles.maintable.jtable.convertColumnIndexToModel(c)+1;

if strcmp(get(src,'checked'),'off') %treat this variable as constant
    set(src,'checked','on')

    handles.isconstant{d}(col)=true;
    handles.activedistribution{d}(col)=0;
    datasets.alldata{d}(:,col)=handles.xdials{d}{1}(col);

else %treat as variable
    if handles.minlimit{d}{handles.maintable.a}==handles.maxlimit{d}{handles.maintable.a}
        errordlg('This variable must be treated as a constant because it only has one allowable value. You must first give it a range of allowable values using the Manage Analyses window.','Error');
        return
    end

    set(src,'checked','off')
    handles.isconstant{d}(col)=false;
    handles.activedistribution{d}(col)=1;

    backupdata=getappdata(handles.fig,'backupdata');
    datasets.alldata{d}(:,col)=backupdata{d}(:,col);
end

guidata(handles.fig,handles);
raveguidata(handles.fig,datasets);

%determine which functions need to update:
updatefuns=[];
for c=find(handles.isfunction{d})
    if ismember(col,handles.funvars{d}{c})
        updatefuns(end+1)=c; %#ok<AGROW>
    end
end

if ~isempty(updatefuns)
    y=raveevaluatefunction(handles.fig,d,updatefuns,datasets.alldata{d},handles);
    datasets.alldata{d}(:,updatefuns)=y;
end

raveguidata(handles.fig,datasets);
raveupdatedataset(handles.fig,handles,'datachanged',[],handles.maintable.d);

%update Table:
handles.maintable.jtable.getModel.setIsConstant(handles.isconstant{d})
handles.maintable.jtable.getTableHeader().resizeAndRepaint();
handles.maintable.jtable.repaint();
