function ravemaintablemakenoisecolumn(src,ev)

handles=guidata(src);
datasets=raveguidata(handles.fig,'datasets');

MouseEvent=get(0,'userdata');

d=handles.maintable.d;

c=handles.maintable.jtable.getColumnModel.getColumnIndexAtX(MouseEvent.getX);
col=handles.maintable.jtable.convertColumnIndexToModel(c)+1;

if strcmp(get(src,'checked'),'off') %treat this variable as constant
    set(src,'checked','on')
    handles.isnoise{d}(col)=true;
else %treat as variable
    if handles.isfunction{d}(col)
        warndlg('Designating a dependent variable as noise has no effect on anything.','Warning');
        return
    end
    set(src,'checked','off')
    handles.isnoise{d}(col)=false;
end

%Check which variables that depend on this variable are now also Random:
depfuns=setdiff(handles.depvars{d}{col},col);
if ~isempty(depfuns)
    for x=depfuns
        handles.allnames{d}(x)=ravemakevariablename(handles,d,x);
        handles.maintable.jtable.getColumnModel().getColumn(x-1).setHeaderValue(handles.allnames{d}{x});
    end
end

%Also mark these columns as being invalid until they are revaluated:
datasets.isvalid{d}(:,depfuns)=false;
handles.maintable.jtable.getModel.setIsDataValid(datasets.isvalid{d});

guidata(handles.fig,handles);
raveguidata(handles.fig,datasets);

%update Table:
handles.maintable.jtable.getModel.setIsNoise(handles.isnoise{d})
handles.maintable.jtable.getTableHeader().resizeAndRepaint();
handles.maintable.jtable.repaint();

