function f=managedatagui(src,ev)

handles=guidata(src);
handles.temp.tabobjects=[]; %category menu objects

f=figure('units','pixels','position',[0 0 651 659],'menubar','none','toolbar','none','windowstyle','modal',...
    'name','Manage data sets','numbertitle','off','resize','off','windowkeypressfcn',@keycap);

origin=get(src,'position');
thispos=get(f,'position');
thispos(1)=origin(1)+origin(3)/2-thispos(3)/2;
thispos(2)=origin(2)+origin(4)/2-thispos(4)/2;
set(f,'position',thispos);
set(f,'closerequestfcn',@closegui)

%set theme:
set(f,'color',handles.colors.frame);

guidata(f,handles);

titleaxes=axes('units','pixels','position',[12 613 312 39],'parent',f,'visible','off');

uipanel1=uipanel('parent',f,'units','pixels','position',[50 440 551 169],'bordertype','etchedin',...
    'backgroundcolor',handles.colors.tabbg);
uipanel2=uipanel('parent',f,'units','pixels','position',[50 74 551 337],'bordertype','etchedin',...
    'backgroundcolor',handles.colors.tabbg,'tag','uipanel2');

topframeaxes=axes('parent',uipanel1,'visible','off','units','pixels','position',[3 124 312 39]);

uicontrol('units','pixels','position',[14 104 520 15],'style','text','backgroundcolor',handles.colors.tabbg,...
    'string','Choose source file, enter a variable name, or leave blank to import data from the clipboard',...
    'fontsize',8,'parent',uipanel1,'hor','left');

uicontrol('style','edit','position',[15 77 475 25],'hor','left','backgroundcolor',[1 1 1],'tag','sourcefiletext','parent',uipanel1);

%display button icons
uicontrol('style','pushbutton','position',[498 79 24 24],'cdata',imread('browse.png'),'parent',uipanel1,...
    'callback',@browsebutton_Callback);

uicontrol('units','pixels','position',[14 53 173 15],'style','text','backgroundcolor',handles.colors.tabbg,...
    'string','Name this Data Set:',...
    'fontsize',8,'parent',uipanel1,'hor','left');

uicontrol('style','edit','position',[14 23 196 27],'hor','left','backgroundcolor',[1 1 1],'tag','newnameedit',...
    'callback',@newnametext_Callback,'parent',uipanel1,'tag','newnametext');

uicontrol('style','checkbox','position',[215 42 215 23],'string','Load Metadata (if .rvm file is present)','tag','metadatacheck','parent',uipanel1,...
    'backgroundcolor',handles.colors.tabbg,'value',1);
uicontrol('style','checkbox','position',[215 24 215 23],'string','Fast Load','tag','fastloadcheck','parent',uipanel1,...
    'backgroundcolor',handles.colors.tabbg,'visible','on','value',1);
makehelpblob(uipanel1,300,26,'helproot?title=Data_Set_File_Formats#Fast_Load',[1 1 1]);

uicontrol('style','checkbox','position',[215 12 215 23],'string','Show Advanced Options','tag','showoptionscheck','parent',uipanel1,...
    'backgroundcolor',handles.colors.tabbg,'enable','off','tooltip','Coming Soon...','visible','off');


uicontrol('style','pushbutton','position',[425 22 113 29],'string','Create this Data Set','parent',uipanel1,...
    'callback',@createbutton_Callback,'tag','createbutton');

bottomframeaxes=axes('units','pixels','position',[6 301 219 31],'parent',uipanel2,'visible','off');

if isempty(handles.datasetnames)
    str='No Data Sets Loaded';
else
    str=handles.datasetnames;
end

uicontrol('units','pixels','position',[15 280 173 15],'style','text','backgroundcolor',handles.colors.tabbg,...
    'string','Select a data set to modify:',...
    'fontsize',8,'parent',uipanel2,'hor','left');

uicontrol('units','pixels','style','popupmenu','position',[15 255 170 22],'parent',uipanel2,'max',1,...
    'string',str,'backgroundcolor',[1 1 1],'tag','datasetmenu','callback',@datasetmenu_Callback);

uicontrol('units','pixels','position',[15 225 173 15],'style','text','backgroundcolor',handles.colors.tabbg,...
    'string','Select a category:',...
    'fontsize',8,'parent',uipanel2,'hor','left');

categorymenu=uicontrol('units','pixels','style','listbox','position',[15 23 170 200],'parent',uipanel2,'max',1,...
    'string',{'Data Set Properties';'Variables';'Optimization'},'backgroundcolor',[1 1 1],...
    'callback',@categorymenu_Callback,'tag','categorymenu');

if ~isempty(handles.datasetnames)
    categorymenu_Callback(categorymenu,[]);
else
    set(categorymenu,'enable','off');
end

axes('parent',uipanel2,'units','pixels','position',[205 20 0.0001 270],'xtick',[],'ytick',[],...
    'ztick',[],'ycolor',[.5 .5 .5],'xcolor',handles.colors.tabbg,'zcolor',[.5 .5 .5]);

uicontrol('style','pushbutton','string','Done','fontsize',16,'callback',@donebutton_Callback,...
    'parent',f,'position',[258 19 133 40],'tag','donebutton');

%make titles
text(0,.4,'Manage Data Sets','parent',titleaxes,'fontname',handles.fonts.title,'fontsize',handles.fonts.titlesize,...
    'color',handles.colors.title,'horizontalalignment','left','verticalalignment','baseline');
text(0,.4,'Create a New Data Set','parent',topframeaxes,'fontname',handles.fonts.tab,'fontsize',handles.fonts.tabsize,...
    'color',handles.colors.text,'horizontalalignment','left','verticalalignment','baseline');
text(0,.2,'Modify Data Sets','parent',bottomframeaxes,'fontname',handles.fonts.tab,'fontsize',handles.fonts.tabsize,...
    'color',handles.colors.text,'horizontalalignment','left','verticalalignment','baseline');


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function browsebutton_Callback(src, eventdata)

sourcefiletext=findobj(ancestor(src,'figure'),'tag','sourcefiletext');
createbutton=findobj(ancestor(src,'figure'),'tag','createbutton');
newnametext=findobj(ancestor(src,'figure'),'tag','newnametext');

[name,path]=uigetfile({'*.txt;*.csv;*.xls;*.xlsx','Data Files (*.txt, *.csv, *.xls, *.xlsx)';'*.bif;*.net;*.oobn;*.dsc','Bayesian Network (*.bif;*.net;*.oobn;*.dsc)';'*.*','All Files (*.*)'},'Choose data file to load:');

if name==0
    set(sourcefiletext,'string','');
    uicontrol(sourcefiletext)
else
    set(sourcefiletext,'string',fullfile(path,name));
    [path,name,ext]=fileparts(fullfile(path,name));
    set(newnametext,'string',name);
    set(createbutton,'enable','on');
    uicontrol(createbutton);
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function newnametext_Callback(src, eventdata)
createbutton=findobj(ancestor(src,'figure'),'tag','createbutton');
txt=get(src,'string');
if ~isempty(txt)
    set(createbutton,'enable','on');
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function createbutton_Callback(src, eventdata)
handles=guidata(src);

sourcefiletext=findobj(ancestor(src,'figure'),'tag','sourcefiletext');
newnametext=findobj(ancestor(src,'figure'),'tag','newnametext');
donebutton=findobj(ancestor(src,'figure'),'tag','donebutton');
datasetmenu=findobj(ancestor(src,'figure'),'tag','datasetmenu');
metadatacheck=findobj(ancestor(src,'figure'),'tag','metadatacheck');
fastloadcheck = findobj(ancestor(src,'figure'),'tag','fastloadcheck');

if isempty(get(sourcefiletext,'string'))
    warndlg('You must browse for a file or enter the name of a variable in your base Matlab workspace.','Information needed')
    return
end


%update uicontrols in this gui to reflect valid data set
set(donebutton,'enable','off','string','Busy...');
drawnow;

dofast = get(fastloadcheck,'value');

%Parse for rave data:
infile=get(sourcefiletext,'string');
[varnames,data,textdata,discretevalues,datatype,datasetnames,datasource]=raveparse2dataset(handles,infile,get(newnametext,'string'),dofast);


for D=1:numel(data) %for each data set found in the file:
    %make data set
    datasetname=datasetnames{D};
    if isempty(datasetname)
        datasetname = ['Dataset ',num2str(numel(handles.datasetnames)+1)];
    end
    
    set(handles.infobar,'string',['Creating dataset ',num2str(D)]);drawnow;
    ravemakedataset(src,numel(handles.datasetnames)+1,infile,datasetname,datasource,varnames{D},data{D},discretevalues{D},datatype{D});
    handles=guidata(src);
    
    d=numel(handles.datasetnames); %actual index of this data set
    
    
    %% process metadata:
    set(handles.infobar,'string',['Processing metadata for dataset ',num2str(D)]);drawnow;
    
    [pathstr, name, ext] = fileparts(infile); 
    
    %look in the folder that contained the data set:
    if exist(fullfile(pathstr,[name,'.rvm']),'file')==2
        ravemetadata=fullfile(pathstr,[name,'.rvm']);
    elseif exist(fullfile(pathstr,[datasetname,'.rvm']),'file')==2
        ravemetadata=fullfile(pathstr,[datasetname,'.rvm']);
    elseif exist(fullfile([pathstr,'metadata.rvm']),'file')==2
        ravemetadata=fullfile(pathstr,[pathstr,'metadata.rvm']);
    else
        ravemetadata=[];
    end
    
    if ~isempty(ravemetadata) && get(metadatacheck,'value')
        [handles,success]=raveloadmetadata(handles,d,ravemetadata);
        if ~success
            set(donebutton,'enable','on','string','Done');
            drawnow;
            %return
        end
    end
    
    pause(0.1); %attempt to avoid java error
    guidata(src,handles);
    guidata(handles.fig,handles)
    
    set(handles.infobar,'string',['Populating data table for dataset ',num2str(D)]);drawnow;
    
    %create tableModel:
    [model,rhmodel]=ravecreatemaintablemodel(handles.fig,[],d,1);
    handles.maintable.models{d}=model;
    handles.maintable.rhmodels{d}=rhmodel;
    handles.maintable.d=d;
    handles.maintable.a=1;
    handles.maintable.x{d}=1:numel(handles.allnames{d});
    drawnow;
    guidata(src,handles);
    
    %check how many columns it has:
    if size(handles.allnames{d},2)==1;
        warndlg('This data set has only one variable. Attempting to create most types of visualizations will cause errors until you add more varaibles to this data set.')
    end
end

set(handles.infobar,'string','All data imported successfully.')
drawnow

%Update managedatagui:
set(donebutton,'enable','on','string','Done');
set(datasetmenu,'string',handles.datasetnames)

%clear creation data:
set(newnametext,'string','')
set(sourcefiletext,'string','')
set(src,'enable','off')
uicontrol(donebutton)

ravefinish;


categorymenu=findobj(ancestor(src,'figure'),'tag','categorymenu');
set(categorymenu,'enable','on');
categorymenu_Callback(categorymenu,[])

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function datasetmenu_Callback(src, ev)
categorymenu=findobj(ancestor(src,'figure'),'tag','categorymenu');
categorymenu_Callback(categorymenu,[])

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function categorymenu_Callback(src,ev)
handles=guidata(src);

datasetmenu=findobj(ancestor(src,'figure'),'tag','datasetmenu');

d=get(datasetmenu,'value');
uipanel2=findobj(ancestor(src,'figure'),'tag','uipanel2');

%delte current tab:
delete(handles.temp.tabobjects);
handles.temp.tabobjects=[];
guidata(src,handles);

if isempty(handles.datasetnames)
    return
end

str=get(src,'string');
switch str{get(src,'value')}
    case 'Data Set Properties'
        nametext=uicontrol('style','text','parent',uipanel2,'string','Data set name:',...
            'fontsize',10,'fontweight','bold','backgroundcolor',[1 1 1],...
            'position',[220 280 200 15],'hor','left');
        nameedit=uicontrol('style','edit','parent',uipanel2,'string',handles.datasetnames{d},...
            'backgroundcolor',[1 1 1],...
            'position',[230 255 200 22],'hor','left','callback',@renamedataset_Callback);
        
        datatext=uicontrol('style','text','parent',uipanel2,'string','Modify data:',...
            'fontsize',10,'fontweight','bold','backgroundcolor',[1 1 1],...
            'position',[220 200 200 15],'hor','left');
        appendbutton=uicontrol('style','pushbutton','parent',uipanel2,'string','Append Data...',...
            'position',[230 170 160 22],'callback',@appendbutton_Callback);
        replacebutton=uicontrol('style','pushbutton','parent',uipanel2,'string','Replace Data...',...
            'position',[230 140 160 22],'callback',@replacebutton_Callback);
        reevaluatebutton=uicontrol('style','pushbutton','parent',uipanel2,'string','Reevaluate Functions...',...
            'position',[230 110 160 22],'callback',@reevaluatebutton_Callback);
        

        handles.temp.tabobjects=[nametext nameedit datatext appendbutton replacebutton reevaluatebutton];
        
    case 'Variables'
        nametext=uicontrol('style','text','parent',uipanel2,'string','Variables:',...
            'fontsize',10,'fontweight','bold','backgroundcolor',[1 1 1],...
            'position',[220 280 200 15],'hor','left');
        renamebutton=uicontrol('style','pushbutton','parent',uipanel2,'string','Rename Variables...',...
            'position',[230 255 160 22],'callback',@renamevarsbutton_Callback);
        definetypesbutton=uicontrol('style','pushbutton','parent',uipanel2,'string','Define Data Types...',...
            'position',[230 225 160 22],'callback',@definetypebutton_Callback);
        definecolorsbutton=uicontrol('style','pushbutton','parent',uipanel2,'string','Define Variable Colors...',...
            'position',[230 195 160 22],'callback',@definecolorsbutton_Callback);
        pickdecidedbutton=uicontrol('style','pushbutton','parent',uipanel2,'string','Select "Constant" Variables...',...
            'position',[230 165 160 22],'callback',@decidebutton_Callback);
        labeltext=uicontrol('style','text','parent',uipanel2,'string','Label rows with value of:',...
            'fontsize',10,'fontweight','bold','backgroundcolor',[1 1 1],...
            'position',[220 130 200 15],'hor','left');
        labelmenu=uicontrol('style','popupmenu','parent',uipanel2,'string',[{'<Label by row number>'},handles.allnames{d}],...
            'position',[230 100 240 22],'callback',@labelmenu_Callback,'value',handles.rowlabelcolumn{d}+1,...
            'backgroundcolor',[1 1 1]);
        disttext=uicontrol('style','text','parent',uipanel2,'string','Random Sampling:',...
            'fontsize',10,'fontweight','bold','backgroundcolor',[1 1 1],...
            'position',[220 70 200 20],'hor','left');       
        distributionbutton=uicontrol('style','pushbutton','parent',uipanel2,'string','Define Distributions...',...
            'position',[230 45 160 22],'callback',@definedistribution_Callback);
        handles.temp.tabobjects=[nametext renamebutton definetypesbutton definecolorsbutton pickdecidedbutton labeltext...
            labelmenu disttext distributionbutton];
    case 'Optimization'
        nametext=uicontrol('style','text','parent',uipanel2,'string','Optimization:',...
            'fontsize',10,'fontweight','bold','backgroundcolor',[1 1 1],...
            'position',[220 280 200 15],'hor','left');
        targetsbutton=uicontrol('style','pushbutton','parent',uipanel2,'string','Define Targets...',...
            'position',[230 255 160 22],'callback',@definetargetsbutton_Callback);
        handles.temp.tabobjects=[nametext targetsbutton];
end

guidata(src,handles);


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function appendbutton_Callback(src, eventdata)
handles=guidata(src);

donebutton=findobj(ancestor(src,'figure'),'tag','donebutton');
datasetmenu=findobj(ancestor(src,'figure'),'tag','datasetmenu');
metadatacheck = findobj(ancestor(src,'figure'),'tag','metadatacheck');
fastloadcheck = findobj(ancestor(src,'figure'),'tag','fastloadcheck');

[name,path]=uigetfile({'*.txt;*.csv;*.xls;*.xlsx','Data Files (*.txt, *.csv, *.xls, *.xlsx)';...
    '*.bif;*.net;*.oobn;*.dsc','Bayesian Network (*.bif;*.net;*.oobn;*.dsc)';'*.*','All Files (*.*)'},...
    'Choose data file to load:');

if name==0 %cancel?
    return
end

infile=fullfile(path,name);

%update uicontrols in this gui to reflect valid data set
set(donebutton,'enable','off','string','Busy...');
drawnow;


dofast = get(fastloadcheck,'value');

%Parse for rave data:
[varnames,data,textdata,discretevalues,datatype,datasetnames,datasource]=raveparse2dataset(handles,infile,'',dofast);

if numel(data)>1
    errordlg('You cannot use Replace Data with a data file that contains multiple data sets (e.g. an Excel file with multiple worksheets). Save the data file you wish to use as a replacement in its own file and try again.');
    return
end

D=get(datasetmenu,'value');

%make data set
raveappendrows(src,D,data{1},[],false(size(data{1},1),1),true(size(data{1},1),1),handles.prefs.defaultrowcolor*ones(size(data{1},1),1),true,1)
handles=guidata(handles.fig);
guidata(src,handles);

%Update managedatagui:
set(donebutton,'enable','on','string','Done');

ravefinish;


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function replacebutton_Callback(src, eventdata)
handles=guidata(src);

donebutton=findobj(ancestor(src,'figure'),'tag','donebutton');
datasetmenu=findobj(ancestor(src,'figure'),'tag','datasetmenu');
metadatacheck=findobj(ancestor(src,'figure'),'tag','metadatacheck');
fastloadcheck=findobj(ancestor(src,'figure'),'tag','fastloadcheck');

[name,path]=uigetfile({'*.txt;*.csv;*.xls;*.xlsx','Data Files (*.txt, *.csv, *.xls, *.xlsx)';...
    '*.*','All Files (*.*)'},...
    'Choose data file to load:');

if name==0 %cancel?
    return
end

infile=fullfile(path,name);

%update uicontrols in this gui to reflect valid data set
set(donebutton,'enable','off','string','Busy...');
drawnow;


dofast = get(fastloadcheck,'value');

%Parse for rave data:
[varnames,data,textdata,discretevalues,datatype,datasetnames,datasource]=raveparse2dataset(handles,infile,'',dofast);

if numel(data)>1
    errordlg('You cannot use Replace Data with a data file that contains multiple data sets (e.g. an Excel file with multiple worksheets). Save the data file you wish to use as a replacement in its own file and try again.');
    return
end

D=get(datasetmenu,'value');

%make data set
ravereplacedataset(src,D,data{1},[],discretevalues,false(size(data{1},1),1),true(size(data{1},1),1),handles.prefs.defaultrowcolor*ones(size(data{1},1),1,'uint16'),true,true)
handles=guidata(handles.fig);
raveupdatedataset(handles.fig,handles,'replaceall',[],D);

%Update managedatagui:
set(donebutton,'enable','on','string','Done');

ravefinish;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function definecolorsbutton_Callback(src, eventdata)
handles=guidata(src);
datasetmenu=findobj(ancestor(src,'figure'),'tag','datasetmenu');
d=get(datasetmenu,'value');

h=ravedefinevariablecolorsgui(src,d);
uiwait(h);
handles=guidata(handles.fig);
guidata(src,handles);



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function donebutton_Callback(src, eventdata)

sourcefiletext=findobj(ancestor(src,'figure'),'tag','sourcefiletext');
unprocessed=get(sourcefiletext,'String');

if ~isempty(unprocessed) %check if they forgot to hit "create data set"
    answer=questdlg('You selected a file but did not create a data set from it. Create this data set now?',...
        'Create data set');
    if strcmp(answer,'Yes')
        createbutton_Callback(src,[])
    end
end

close(ancestor(src,'figure'));

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function reevaluatebutton_Callback(src, eventdata)
handles=guidata(src);

answer=questdlg('Re-evaluate all functions for the selected data set now? (Use this if you have made changes to a function after it was loaded/created on the Model tab.)','Re-evaluate functions');
if ~strcmpi(answer,'yes');return;end

datasets=raveguidata(handles.fig,'datasets');
donebutton=findobj(ancestor(src,'figure'),'tag','donebutton');
datasetmenu=findobj(ancestor(src,'figure'),'tag','datasetmenu');

set(donebutton,'enable','off','string','Busy...');
drawnow;
d=get(datasetmenu,'value');
funs=find(handles.isfunction{d});
newouts=raveevaluatefunction(handles.fig,d,funs,datasets.alldata{d},handles);
datasets.alldata{d}(:,funs)=newouts;
datasets.isvalid{d}(:,funs)=true;
guidata(src,handles);
raveguidata(handles.fig,'datasets',datasets);
raveupdatedataset(handles.fig,handles,'datachanged',[],d);

%Important: update handles of managedatagui, which may have been changed by
%raveupdatedataset
handles=guidata(handles.fig);
guidata(src,handles);

ravefinish;
set(donebutton,'enable','on','string','Done');

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function definetypebutton_Callback(src, eventdata)
handles=guidata(src);
datasetmenu=findobj(ancestor(src,'figure'),'tag','datasetmenu');
d=get(datasetmenu,'value');

h=ravedefinetypesgui(src,d);
uiwait(h);
handles=guidata(handles.fig);
guidata(src,handles);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function definetargetsbutton_Callback(src,eventdata)
handles=guidata(src);

datasetmenu=findobj(ancestor(src,'figure'),'tag','datasetmenu');
d=get(datasetmenu,'value');

hhh=ravedefinetargetsgui(src,d);
uiwait(hhh)
handles=guidata(handles.fig);
guidata(src,handles);


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function decidebutton_Callback(src, eventdata, handles)
msgbox('This feature is not yet implemented in this GUI, however, you can hold variables constant by right clicking their column header in the data table and checking "Treat as Constant."','Coming Soon','help')


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function closegui(src,ev)
%send updated handles back to main rave window
handles=guidata(src);
if ishandle(handles.fig)
    guidata(handles.fig,handles);
end
delete(src)

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function renamedataset_Callback(src,eventdata)
handles=guidata(src);
datasetmenu=findobj(ancestor(src,'figure'),'tag','datasetmenu');

d=get(datasetmenu,'value');

handles.datasetnames{d}=get(src,'string');
guidata(src,handles);
guidata(handles.fig,handles);

set(datasetmenu,'string',handles.datasetnames);



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function renamevarsbutton_Callback(src, ev)
msgbox('This feature is not yet implemented in this GUI, however, you can rename variables by right clicking their column header in the data table and selecting "Rename".','Coming Soon','help')


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function labelmenu_Callback(src, ev)
handles=guidata(src);
datasetmenu=findobj(ancestor(src,'figure'),'tag','datasetmenu');
d=get(datasetmenu,'value');
handles.rowlabelcolumn{d}=get(src,'value')-1;
guidata(src,handles);
guidata(handles.fig,handles);


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function definedistribution_Callback(src,ev)
handles=guidata(src);

datasetmenu=findobj(ancestor(src,'figure'),'tag','datasetmenu');
d=get(datasetmenu,'value');

hhh=ravedefinevariabledistributiongui(src,d);
uiwait(hhh);
handles=guidata(handles.fig);
guidata(src,handles);


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function keycap(src,ev)
try %try because i'm not sure if older versions use same format for eventdata:
    if strcmp(ev.Key,'escape')
        close(gcbf);
    end
end