function newaxeschangelistener(src,ev,axisname,newvalue,handles)
%src is the handles of handles.allgraphs whose ticks changed
%axisname is either "XTick", "YTick", or "ZTick"
%newvalue is the new value of these ticks.
%
%
% RAVE Rapid Analysis and Visualization Environment
% Copyright (C) 2014 Georgia Tech Research Corporation
% ALL RIGHTS RESERVED
%
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU General Public License
% as published by the Free Software Foundation; version 2
% of the License.
%
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.

%This function runs any time the axes are resized and xtickmode etc are set to auto, regardless of whether
%the ticks actually change. ALso runs when xticklabelmodes are set to auto,
%even if other things are manual. Note that it usually does not run
%immediately after the xlim/ylim properties are set, but waits until a
%drawnow or a get of the axis properties.

ax=src;
if isempty(axisname);return;end

if any(axisname=='x')
    ai=find(handles.allgraphs==ax);
    try %gives error when resizing tables because tables store a uipanel in fakerax
        set([handles.fakeax(ai) handles.fakerax(ai)],'xlim',get(ax,'xlim'),...
            'xtick',newvalue{1});
    end
end

if any(axisname=='y')
    ai=find(handles.allgraphs==ax);
    try %gives error when resizing tables because tables store a uipanel in fakerax
        set([handles.fakeax(ai) handles.fakerax(ai)],...
            'ylim',get(ax,'ylim'),'ytick',newvalue{2});
    end
end

if any(axisname=='z')
    ai=find(handles.allgraphs==ax);
    try%gives error when resizing tables because tables store a uipanel in fakerax
        set([handles.fakeax(ai) handles.fakerax(ai)],...
            'zlim',get(ax,'zlim'),'ztick',newvalue{3});
    end
end

thistype=get(ax,'userdata');
if ~isempty(which(['raveupdateticks',thistype]))
    eval(['raveupdateticks',thistype,'(ax,[],''xyz'');'])
end
