%Default Directory
function raveeditprefsdefaultdir(src,ev)

% RAVE Rapid Analysis and Visualization Environment
% Copyright (C) 2013 Georgia Tech Research Corporation
% ALL RIGHTS RESERVED
% 
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU General Public License
% as published by the Free Software Foundation; version 2
% of the License.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% Written by: Matthew Daskilewicz mdaskilewicz@asdl.gatech.edu

handles=guidata(src);

txt1=uicontrol('style','text','string','Enter the path to the directory in which Rave should store files it creates:',...
    'position',[230 428 640 20],'backgroundcolor',handles.colors.frame,'fontsize',10,'hor','left',...
    'parent',src);

edit1=uicontrol('style','edit','string',handles.prefs.defaultdir,...
    'position',[230 408 460 22],'backgroundcolor',[1 1 1],'hor','left','callback',@edit_Callback,...
    'tag','edit');

browsebutton=uicontrol('parent',src,'style','pushbutton','position',[700 406 24 24],'cdata',imread('browse.png'),...
    'callback',@browsebutton_Callback);


handles.temp.tabobjects=[txt1 edit1 browsebutton];

guidata(src,handles);


function edit_Callback(src,ev)
handles=guidata(src);

if ~isdir(get(src,'string'))
    answer=questdlg('Specified directory does not exist, would you like to create it now?');
    if strcmpi(answer,'yes')
        mkdir(get(src,'string'));
    else
       set(src,'string',handles.defaultdir);
       return        
    end

end

%Note: set this in 2 places...different functions refer to either of these:
handles.defaultdir=get(src,'string');    
handles.prefs.defaultdir=get(src,'string');
guidata(src,handles);

function browsebutton_Callback(src,ev)
handles=guidata(src);

path=uigetdir(handles.prefs.defaultdir,'Choose Default Folder');

if path~=0
    set(findobj(handles.temp.tabobjects,'tag','edit'),'string',path);
    handles.defaultdir=path;
    handles.prefs.defaultdir=path;
    guidata(src,handles);
end

