%Graph Background Colors
function raveeditprefsgraphcolors(src,ev)

% RAVE Rapid Analysis and Visualization Environment
% Copyright (C) 2013 Georgia Tech Research Corporation
% ALL RIGHTS RESERVED
% 
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU General Public License
% as published by the Free Software Foundation; version 2
% of the License.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% Written by: Matthew Daskilewicz mdaskilewicz@asdl.gatech.edu

handles=guidata(src);

txt1=uicontrol('style','text','string','Background Color Themes',...
    'position',[230 428 640 20],'backgroundcolor',handles.colors.frame,'fontsize',10,'hor','left',...
    'parent',src,'fontweight','bold');
txt2=uicontrol('style','text','string','You can define four background color themes. Workspace objects that use these themes show four "Background Color" buttons near the top of their Fomat Tab. Change the colors of the different theme elements by clicking on the corresponding buttons below.',...
    'position',[230 310 540 120],'backgroundcolor',handles.colors.frame,'fontsize',10,'hor','left',...
    'parent',src,'fontweight','normal');
txt3=uicontrol('style','text','string',{'Axes Color:';'';'Background Color:';'';'Faint Grid:';'';'Bold Grid:';'';'Text:'},...
    'position',[200 160 150 160],'backgroundcolor',handles.colors.frame,'fontsize',10,'hor','right',...
    'parent',src,'fontweight','normal');
txt4=uicontrol('style','text','string','Theme 1      Theme 2       Theme 3      Theme 4',...
    'position',[200 320 450 22],'backgroundcolor',handles.colors.frame,'fontsize',10,'hor','right',...
    'parent',src,'fontweight','normal');

for r=1:5
    for c=1:4
        buttons(r,c)=uicontrol('parent',src,'style','pushbutton','position',[390+75*(c-1) 300-32*(r-1) 24 24],...
            'backgroundcolor',handles.colors.axes{c}(r,:),'userdata',[r c],'callback',@colorblob_Callback);         %#ok<AGROW>
    end
end

handles.temp.tabobjects=[txt1 txt2 txt3 txt4 buttons(:)'];

guidata(src,handles);


function colorblob_Callback(src,ev)
handles=guidata(src);
udat=get(src,'userdata');
newcolor=ravecolorchooser(handles.fig,handles.colors.axes{udat(2)}(udat(1),:),'Choose a color');
set(src,'backgroundcolor',newcolor);
handles.colors.axes{udat(2)}(udat(1),:)=newcolor;
guidata(src,handles);



