%Mouseover Effects
function raveeditprefsmouseover(src,ev)
% RAVE Rapid Analysis and Visualization Environment
% Copyright (C) 2013 Georgia Tech Research Corporation
% ALL RIGHTS RESERVED
% 
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU General Public License
% as published by the Free Software Foundation; version 2
% of the License.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% Written by: Matthew Daskilewicz mdaskilewicz@asdl.gatech.edu

handles=guidata(src);

c1=uicontrol('style','checkbox','string','Enable workspace object mouseover effects',...
    'position',[260 428 540 20],'backgroundcolor',handles.colors.frame,'fontsize',10,'hor','left',...
    'parent',src,'fontweight','normal','value',handles.prefs.processmouseovers,'callback',@enablecheck_callback);
c2=uicontrol('style','text','string','Delay before displaying mouseover effect (milliseconds):',...
    'position',[260 393 540 20],'backgroundcolor',handles.colors.frame,'fontsize',10,'hor','left',...
    'parent',src,'fontweight','normal');
c3=uicontrol('style','edit','string',num2str(1000*handles.prefs.mouseoverdelay),...
    'position',[270 368 80 20],'backgroundcolor',[1 1 1],'fontsize',10,'hor','center',...
    'parent',src,'fontweight','normal','value',handles.prefs.alwaysupdate,'callback',@delayedit_callback);
c4=uicontrol('style','text','string',{'(Setting the delay to 0 may cause excessive computations';'every time you move the mouse.)'},...
    'position',[260 298 540 60],'backgroundcolor',handles.colors.frame,'fontsize',10,'hor','left',...
    'parent',src,'fontweight','normal');

handles.temp.tabobjects=[c1 c2 c3 c4 ];

guidata(src,handles);


function enablecheck_callback(src,ev)
handles=guidata(src);
handles.prefs.processmouseovers=get(src,'value');
guidata(src,handles);

function delayedit_callback(src,ev)
handles=guidata(src);
handles.prefs.mouseoverdelay=str2double(get(src,'string'))/1000;
guidata(src,handles);


