function [w,h]=ravecalculatestringlengthfast(str,javaobj)
%Calculates the pixel dimensions of the specified string, using the
%specified javaobj, which may be either:
%  handles.fontmetrics.tick
%  handles.fontmetrics.graph
%  handles.fontmetrics.graphtitle
%
%output w is a vector of length(str) when str is a cell array of
%strings (or is a scalar if str is a string).
%output h is always a scalar regardless of length(str) since the height is
%a property of the font only, regardless of which characters are being
%displayed. 

w=javaobj.getWidth(str);

if nargout==2
    h=ceil(javaobj.getHeight(str));
end
