function p=ravedrawdistribution(handles,src,axis,d,a,x,dist,scale,pvpairs)
%Draws the PDF of the distribution specified by "dist" on the axes specified by "src"
%along the axis specified by "axis". The max height of the distribution is
%controlled by "scale"
%
%The PDF is drawn as a patch object with properties specified by pvpairs


%get  this distribution:

settings=handles.distributions{d}{x}{dist};
settings=raveprocessdistribution(handles,settings,d,a);

if isempty(which(['distributionpdf',settings.type]))
    p=[];
    return
end

fcn=str2func(['distributionpdf',settings.type]);

%make evnely spaced x points along the specified axis:
lims=get(src,[axis,'lim']);

x=linspace(lims(1),lims(2),1000);

y=fcn(x,settings);

%normalize y data:

y=y./max(y);
y=y.*scale;

%scale y data to match lims:

switch axis
    case 'x'
        ylimz=get(src,'ylim');
    case 'y',
        ylimz=get(src,'xlim');
end

y=y.*(ylimz(2)-ylimz(1))+ylimz(1);

p=patch(x,y,[.85 .85 .85],'parent',src,'edgecolor','none');













