function raveduplicatevariable(src,d,x,newname)
%Duplicates variable x in dataset d, with the new variable going to the
%(end+1) position.
handles=guidata(src);

if nargin<4
    newname=handles.basenames{d}{x};
end


datasets=raveguidata(handles.fig,'datasets');
% textdata=raveguidata(handles.fig,'textdata');
vectordata=raveguidata(handles.fig,'vectordata');

datasets.datatype{d}{end+1}=handles.datatype{d}{x};
datasets.alldata{d}(:,end+1)=datasets.alldata{d}(:,x);
datasets.isvalid{d}(:,end+1)=datasets.isvalid{d}(:,x);
raveguidata(src,'datasets',datasets);

% textdata.alltext{d}=[textdata.alltext{d},cell(size(textdata.alltext{d},1),1)];
% raveguidata(handles.fig,textdata);

vectordata.vectordata{d}=[vectordata.vectordata{d},cell(size(vectordata.vectordata{d},1),1)];
raveguidata(src,'vectordata',vectordata);


handles.basenames{d}{end+1}=newname;
handles.datasetlinks{d}{end+1}=handles.datasetlinks{d}{x};
handles.datasetlinkinfo{d}{end+1}=handles.datasetlinkinfo{d}{x};
handles.variablecolors{d}(end+1,:)=handles.variablecolors{d}(x,:);
handles.allunits{d}{end+1}=handles.allunits{d}{x}; %havent implemented this yet
handles.isincluded{d}(end+1)=handles.isincluded{d}(x);
handles.isconstant{d}(end+1)=handles.isconstant{d}(x);
handles.isfunction{d}(end+1)=handles.isfunction{d}(x);
handles.funclass{d}{end+1}=handles.funclass{d}{x};
handles.funattributes{d}{end+1}=handles.funattributes{d}{x};
handles.funnames{d}{end+1}=handles.funnames{d}{x};
handles.funvars{d}{end+1}=handles.funvars{d}{x};
handles.depvars{d}{end+1}=handles.depvars{d}{x};
handles.nargout{d}(end+1)=handles.nargout{d}(x);
handles.datatype{d}{end+1}=handles.datatype{d}{x};
handles.isnoise{d}(end+1)=handles.isnoise{d}(x);
handles.preferences{d}(end+1)=handles.preferences{d}(x);
handles.targetvalues{d}(end+1)=handles.targetvalues{d}(x);
handles.isobjective{d}(end+1)=handles.isobjective{d}(x);
handles.maintable.colwidths{d}(end+1)=handles.maintable.colwidths{d}(x);
handles.distributions{d}{end+1}=handles.distributions{d}{x}; 
handles.aggregatingstatistic{d}{end+1}=handles.aggregatingstatistic{d}{x};
handles.activedistribution{d}(end+1)=handles.activedistribution{d}(x);

for a=1:numel(handles.analysisnames)
    handles.xdials{d}{a}(end+1)=handles.xdials{d}{a}(x);
    handles.minlimit{d}{a}(end+1)=handles.minlimit{d}{a}(x);
    handles.maxlimit{d}{a}(end+1)=handles.maxlimit{d}{a}(x);
    handles.minfilter{d}{a}(end+1)=handles.minfilter{d}{a}(x);
    handles.maxfilter{d}{a}(end+1)=handles.maxfilter{d}{a}(x);
    handles.discretevalues{d}{a}{end+1}=handles.discretevalues{d}{a}{x};
end

handles.allnames{d}(end+1)=ravemakevariablename(handles,d,numel(handles.basenames{d}));

guidata(src,handles);

%update maintable udata to display new columns:
handles.maintable.x{d}=union(handles.maintable.x{d},size(handles.funnames{d},2));
raveupdatedataset(handles.fig,handles,'addcolumns',[],d);
ravefinish; %make a done sound.

set(handles.infobar,'string','New column successfully added to data set.')


