function g=raveevaluateconstraint(handles,d,a,thisconstraint,indata,ignore)
%NOTE: for speed, this function takes in handles directly instead of src. 
%evaluates the constraint with index stored in thisconstraint using the data stored in data.
%thisconstraint is an index into:
%handles.constrainthandles{udata.view.dataset}{udata.view.analysis}{thisconstraint}
%ignore is a logical vector of length=size(indata,2) (=numvars) where "true" means do not evaluate this
%function (if that varaible is modeled by a function). Use this when indata
%contains the exact values you want to use for variables modeled with
%function. Otherwise the columns of indata (for which ignore=false) that
%are inputs to the constraint and are modeled as functions will be evaluated using their independent
%variables before the constraint is evaluted. 

% RAVE Rapid Analysis and Visualization Environment
% Copyright (C) 2010 Georgia Tech Research Corporation
% ALL RIGHTS RESERVED
% 
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU General Public License
% as published by the Free Software Foundation; version 2
% of the License.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% Written by: Matthew Daskilewicz mdaskilewicz@asdl.gatech.edu


varnumbers=handles.constraintvars{d}{a}{thisconstraint};
varnumbers=setdiff(varnumbers,find(ignore)); %dont evaluate functions of ignored vars

if ~isempty(varnumbers)
%evaluate all functions necessary for this constraint:
respdata=raveevaluatefunction(handles.fig,d,varnumbers,indata,handles);
indata(:,varnumbers)=respdata;
end

%solve evaluate this constraint for y variable:

thishandle=handles.constrainthandles{d}{a}{thisconstraint};
g=thishandle(indata);

