function axiscanvas=ravegetaxiscanvas(fig,update)
%gets the axis canvas associated with the specified figure

if nargin<2
    update='';
end

handles=guidata(fig);

%for some reason isjava doesn't work with axis canvas, so check if it's
%valid by just trying to use it:
try handles.axiscanvas.doLayout;
    isvalid=true;
catch
    isvalid=false;
end


if isvalid && ~strcmpi(update,'update')
    axiscanvas=handles.axiscanvas;
else %check for new axis canvas
   
    %ishg2parent was removed in 2015b, so screw it, just try/catch:
    try
       axiscanvas = fig.JavaFrame.fHG2Client.getAxisComponent.getComponent(1);
    catch
          axiscanvas=findjobj(fig,'class','AxisCanvas');
    end
    
    %{
    v=ver('matlab'); %not sure what version ishg2parent appeared...
    
    if v.Version(1)~='7' && ishg2parent(fig)
        %handles.axiscanvas=findjobj(fff,'class','com.mathworks.hg.peer.JavaSceneServerCanvas'); %not sure what to do here yet...
        axiscanvas = fig.JavaFrame.fHG2Client.getAxisComponent.getComponent(1);
    else
        axiscanvas=findjobj(fig,'class','AxisCanvas'); %<-- used to provide a graphics context for determining string wrapping
    end
    
    %}
end