function ravemaintableeditrownotes(src,ev)
%Edit the row notes of the selected row. 

handles=guidata(src);

d=handles.maintable.d;
a=handles.maintable.a;

isselected=handles.maintable.jtable.getSelectedRows();

for g=1:numel(isselected);
   isselected(g)=handles.maintable.models{d}.modelIndex(isselected(g)); 
end

isselected=isselected+1;


if numel(isselected)~=1
    errordlg('You must select a single row to edit row notes')
    return
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%Make figure to edit notes:
datanotes=raveguidata(handles.fig,'datanotes');
datasets = raveguidata(handles.fig,'datasets');

thesenotes = datanotes{d}{isselected};
if isempty(thesenotes)
    thesenotes='';
end

f=figure('units','pixels','position',[0 0 500 300],'menubar','none','toolbar','none','windowstyle','modal',...
    'name','Edit row notes','numbertitle','off','resize','off','windowkeypressfcn',@keycap);

origin=get(handles.fig,'position');
thispos=get(f,'position');
thispos(1)=origin(1)+origin(3)/2-thispos(3)/2;
thispos(2)=origin(2)+origin(4)/2-thispos(4)/2;
set(f,'position',thispos);
set(f,'closerequestfcn',@closegui)

%set theme:
set(f,'color',handles.colors.frame);

guidata(f,handles);

titletext = uicontrol('style','text','max',100,'position',[20 250 460 50],'parent',f,'hor','left',...
    'backgroundcolor',handles.colors.frame,'string',['Editing notes for row: ',ravegetrowlabelstring(handles,datasets,d,a,isselected)],'fontsize',10);

editbox = uicontrol('style','edit','max',100,'position',[20 50 460 200],'parent',f,'hor','left',...
    'backgroundcolor',[1 1 1],'string',thesenotes,'tag','editbox','userdata',isselected);

donebutton = uicontrol('style','pushbutton','string','Done','fontsize',16,'callback',@donebutton_Callback,...
    'parent',f,'position',[200 5 133 40],'tag','donebutton');

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function keycap(src,ev)
try %try because i'm not sure if older versions use same format for eventdata:
    if strcmp(ev.Key,'escape')
        close(gcbf);
    end
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function closegui(src,ev)
%Store new notes:
handles=guidata(src);
editbox = findobj(gcbf,'tag','editbox');
notes = get(editbox,'string');
idx = get(editbox,'userdata');
datanotes = raveguidata(handles.fig,'datanotes');
d=handles.maintable.d;
datanotes{d}{idx} = notes;
raveguidata(handles.fig,'datanotes',datanotes);

delete(src)

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function donebutton_Callback(Src,ev)
close(gcf);
