function ravemakedoublecolorbar(src,ev,ai) %#ok<INUSD>
%an annoying special case for the 2d carpet plot, which has two colorbars.
%
% RAVE Rapid Analysis and Visualization Environment
% Copyright (C) 2010 Georgia Tech Research Corporation
% ALL RIGHTS RESERVED
%
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU General Public License
% as published by the Free Software Foundation; version 2
% of the License.
%
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
%
% Written by: Matthew Daskilewicz mdaskilewicz@asdl.gatech.edu
handles=guidata(src);

if nargin<3;
    ai=handles.activeindex;
end


udata=get(handles.fakeax(ai),'userdata');
legdata=get(handles.fakerax(ai),'userdata');

d=udata.view.dataset;
a=udata.view.analysis;

%remove old cbar from legdata (for rasterizing/exporting);
oldcbar=findobj(handles.fig,'tag','Colorbar','userdata',ai);

if ~isempty(oldcbar)
    legdata=setdiff(legdata,oldcbar);
    delete(oldcbar)
    set(handles.fakerax(ai),'userdata',legdata);
end

%make a new colorbar if needed
if ~udata.format.colorbar;return;end
%if ~udata.view.c;return;end

%global or local scaling?
lims1=[handles.minlimit{d}{a}(udata.view.z) handles.maxlimit{d}{a}(udata.view.z)];
if lims1(1)==lims1(2)
    lims1(1)=lims1(1)-0.5;
    lims1(2)=lims1(2)+0.5;
elseif any(isnan(lims)) || any(isinf(lims));
    lims=[0 1];
end


axpos=get(handles.allgraphs(ai),'position');
aaa=axes('parent',handles.wspanel,'visible','on','units','pixels','position',[axpos(1)+axpos(3)+30 axpos(2) 27 axpos(4)],...
    'fontname',handles.fonts.graph,'fontsize',handles.fonts.graphsize,'hittest','off','box','on','layer','top');

cdata=get(handles.fig,'colormap');
cdata=permute(cdata,[1,3,2]);
image('cdata',cdata,'parent',aaa);

set(aaa,'xtick',[],'xticklabel','','yaxislocation','right','ylim',lims1);

newyticks=get(aaa,'ytick');
newyticklabels=get(aaa,'yticklabel');
properYrange=[128*(udata.format.mcmap1-1)+1 128*udata.format.mcmap1];
set(aaa,'ylim',properYrange,'ylimmode','manual');

if udata.format.reversecolors
    set(aaa,'ydir','reverse')
    newyticklabels=flipud(newyticklabels);
else
    set(aaa,'ydir','normal')
end

newscaledticks=interp1(lims1,properYrange,newyticks);
set(aaa,'ytick',newscaledticks,'yticklabel',newyticklabels);
set(aaa,'userdata',ai,'tag','Colorbar');
udata.format.colorbar=1;
legdata=union(legdata,aaa);
set(handles.fakerax(ai),'userdata',legdata);
ylab=get(aaa,'ylabel');
set(ylab,'string',handles.allnames{udata.view.dataset}{udata.view.z},'interpreter',handles.prefs.interpreter,...
    'fontsize',handles.fonts.graphsize,'fontname',handles.fonts.graph);

xlim=get(aaa,'xlim');
ylim=get(aaa,'ylim');
pos=get(aaa,'pos');


%% number 2:
%global or local scaling?
lims2=[handles.minlimit{d}{a}(udata.view.c) handles.maxlimit{d}{a}(udata.view.c)];
if lims2(1)==lims2(2)
    lims2(1)=lims2(1)-0.5;
    lims2(2)=lims2(2)+0.5;
elseif any(isnan(lims2)) || any(isinf(lims2));
    lims2=[0 1];
end
axpos=get(handles.allgraphs(ai),'position');
aaa=axes('parent',handles.wspanel,'visible','on','units','pixels','position',[axpos(1)+axpos(3)+30+80 axpos(2) 27 axpos(4)],...
    'fontname',handles.fonts.graph,'fontsize',handles.fonts.graphsize,'hittest','off','layer','top','box','on');

cdata=get(handles.fig,'colormap');
cdata=permute(cdata,[1,3,2]);
image('cdata',cdata,'parent',aaa);

set(aaa,'xtick',[],'xticklabel','','yaxislocation','right','ylim',lims2);

newyticks=get(aaa,'ytick');
newyticklabels=get(aaa,'yticklabel');
properYrange=[128*(udata.format.mcmap2-1)+1 128*udata.format.mcmap2];
set(aaa,'ylim',properYrange,'ylimmode','manual');

if udata.format.reversecolors
    set(aaa,'ydir','reverse')
    newyticklabels=flipud(newyticklabels);
else
    set(aaa,'ydir','normal')
end

newscaledticks=interp1(lims2,properYrange,newyticks);
set(aaa,'ytick',newscaledticks,'yticklabel',newyticklabels);
set(aaa,'userdata',ai,'tag','Colorbar');
udata.format.colorbar=1;
legdata=union(legdata,aaa);
set(handles.fakerax(ai),'userdata',legdata);
ylab=get(aaa,'ylabel');
set(ylab,'string',handles.allnames{udata.view.dataset}{udata.view.c},'interpreter',handles.prefs.interpreter,...
    'fontsize',handles.fonts.graphsize,'fontname',handles.fonts.graph);

xlim=get(aaa,'xlim');
ylim=get(aaa,'ylim');
pos=get(aaa,'pos');

