function [destination,newfun]=ravemakefile(tempfilename,destination)
%Copies the file stored at tempfilename to the location destination,
%unless a file with the same name as destination already exists anywhere on your path,
%in which case:
%
% If the file currently named destination is identical to the file
% in tempfilename, rave takes no action and this function returns
% destination. 
%
% If the file currently living at destination is different than that
% file in tempfilename, rave copies tempfilename to a different filename in
% the same folder as destination, and this function returns the new
% file name.

%check if another file on the path already has this name:
[path,basefilename,ext]=fileparts(destination);
filename=basefilename;
w=which(filename);
q=2;
newfun=true;

while ~isempty(w)

    %check if these two files are identical:
    fid=fopen(tempfilename);
    fid2=fopen(w);
    A=fread(fid);
    B=fread(fid2);
    fclose all;
    
    if numel(A)==numel(B) && all(A==B); %files are identical
        %Delete new file and just use old file:
        delete(tempfilename)
        %need to recheck filename because it may have different letter
        %cases:
        [p,n,e]=fileparts(w);
        FileName=[n,e];
        newfun=false;
        break
    else
        %need to make new filename
        filename=[basefilename,'_',int2str(q)];
        w=which(filename);
        q=q+1;
    end
end

destination=fullfile(path,[filename,ext]);

if newfun
    movefile(tempfilename,destination);
    %refresh path to include this function
    rehash
end

