function attr = raveparsefunctionattributes(filename)
%Parses the file in filename for attributes on the 2nd line, with no dependence on handles/src/etc. 
%If filename does not exist or is not on path, returns {''}. 

fid = fopen(filename);
    
if fid==-1 %error, file not found
    attr={''};
    return
end

firstline=fgetl(fid);
secondline=fgetl(fid);

if ischar(secondline)
    secondline = strtrim(secondline);    
    secondline=[secondline,' ']; %ensure there is a trailing space for regexp
    attributes = regexp(secondline,'#([\w]*)','tokens');
    if isempty(attributes)
        attr={''};
        return
    end
    %Peel off outer layer of cells:
    attributes = [attributes{:}];
    attr=lower(attributes);
end
