function askbox=raveresizewindow(src,ev)
%This is the gui that asks the user to specify a new window position.

load raveprefs

screensize=get(0,'monitorposition');
screensize=screensize(1,:);
screensize(3)=screensize(3)-screensize(1)+1;  

askbox=figure('units','pixels','position',[screensize(1)+screensize(3)/2-350 screensize(2)+screensize(4)/2-225 700 450],...
    'numbertitle','off','menubar','none','name','RAVE Setup','color',raveprefs.colors.frame,...
    'resize','on','windowstyle','normal','resizefcn',@windowresize_Callback);

%cancelbutton=uicontrol('style','pushbutton','position',[420 10 120 26],'string','Cancel','fontsize',12,'callback',@cancelbutton_Callback);
uicontrol('style','pushbutton','position',[560 10 120 26],'string','Next','fontsize',12,'callback',@nextbutton2_Callback);

uicontrol('style','text','string','Specify size and position of RAVE window',...
    'position',[30 380 640 40],'backgroundcolor',raveprefs.colors.frame,'fontsize',10,'hor','left','fontweight','bold');

uicontrol('style','text','string','Resize and drag *this window* to the desired size and position that you wish the RAVE window to appear on your screen. It is recommended that you simply maximize this window on the monitor on which you wish RAVE to appear. In order to function properly, the window must be at least 850 pixels high. Note, the RAVE window is not resizable during use.',...
    'position',[30 320 640 80],'backgroundcolor',raveprefs.colors.frame,'fontsize',10,'hor','left','fontweight','normal');

uicontrol('style','text','string','Current size is too small. Make this window at least 400 pixels taller. Click "Next" when you are finished.',...
    'position',[30 260 640 40],'backgroundcolor',raveprefs.colors.frame,'fontsize',10,'hor','left','fontweight','normal','foregroundcolor',[1 0 0],'tag','windowsizetext');

function windowresize_Callback(src,ev)
windowsizetext=findobj(src,'tag','windowsizetext');
if isempty(windowsizetext);return;end;

pos=get(src,'position');

height=pos(4);

if height>=900
    set(windowsizetext,'string','Window is large enough. Click "Next" when you are finished sizing.','foregroundcolor',[0 .8 0]);
else
    set(windowsizetext,'string',['Current size is too small. Make this window at least ',num2str(850-height),' pixels taller. Click "Next" when you are finished.'],'foregroundcolor',[1 0 0]);
end

drawnow;



function nextbutton2_Callback(src,ev)
prefspath=which('raveprefs.mat');
load raveprefs
raveprefs.preferredposition=get(gcf,'position');
save(prefspath,'raveprefs');
close(gcf);

