function weights=ravetrigridn(m,n)
%makes an n-d regular barycentric grid with m pts along each simplex side.
%All values are normalized from 0-1. 
%
%
% RAVE Rapid Analysis and Visualization Environment
% Copyright (C) 2010 Georgia Tech Research Corporation
% ALL RIGHTS RESERVED
%
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU General Public License
% as published by the Free Software Foundation; version 2
% of the License.
%
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.

w=fullfactbuild(m*ones(1,n));
w=w-1;
keepz=sum(w,2)==m-1;
w=w(keepz,:);
weights=(w)./(m-1);

