function raveprefs=ravevalidateprefs(raveprefs)
%checks the raveprefs structure to ensure it is up to date. Adds any new
%preferences at their new default values.

newprefs=ravemakedefaultprefs;

newfields=fieldnames(newprefs);
oldfields=fieldnames(raveprefs);
for n=1:numel(newfields)
    if ~ismember(newfields{n},oldfields)
        raveprefs.(newfields{n})=newprefs.(newfields{n});        
    end
end

newfields=fieldnames(newprefs.colors);
oldfields=fieldnames(raveprefs.colors);
for n=1:numel(newfields)
    if ~ismember(newfields{n},oldfields)
        raveprefs.colors.(newfields{n})=newprefs.colors.(newfields{n});        
    end
end

newfields=fieldnames(newprefs.fonts);
oldfields=fieldnames(raveprefs.fonts);
for n=1:numel(newfields)
    if ~ismember(newfields{n},oldfields)
        raveprefs.fonts.(newfields{n})=newprefs.fonts.(newfields{n});        
    end
end

newfields=fieldnames(newprefs.animation);
oldfields=fieldnames(raveprefs.animation);
for n=1:numel(newfields)
    if ~ismember(newfields{n},oldfields)
        raveprefs.animation.(newfields{n})=newprefs.animation.(newfields{n});        
    end
end

%check for new 5 line axis coloration:
if size(raveprefs.colors.axes{1},1)==4
    raveprefs.colors.axes{1}(5,:)=[0 0 0];
    raveprefs.colors.axes{2}(5,:)=[0 0 0];
    raveprefs.colors.axes{3}(5,:)=[0 0 0];
    raveprefs.colors.axes{4}(5,:)=[0 0 0];    
end


%correct data types:
raveprefs.defaultrowcolor=uint16(raveprefs.defaultrowcolor);

%ensure that default directory exists
if ~isdir(raveprefs.defaultdir)
    mkdir(raveprefs.defaultdir);
end
addpath(raveprefs.defaultdir)
try
    savepath
end
rehash;




