function ravewheelscroll(src,eventdata)
% RAVE Rapid Analysis and Visualization Environment
% Copyright (C) 2010 Georgia Tech Research Corporation
% ALL RIGHTS RESERVED
% 
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU General Public License
% as published by the Free Software Foundation; version 2
% of the License.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% Written by: Matthew Daskilewicz mdaskilewicz@asdl.gatech.edu


handles=guidata(src);

if handles.tablemode;return;end;

%If a uicontrol is selected, do its scroll function instead:
if strcmp(get(gco,'type'),'uicontrol') && strcmp(get(gco,'style'),'listbox')
    return
end


%Check what object is under the cursor and see if it has its own scroll function. In order for this to work, the handles.allgraphs
%of the object under the handle must have a hittest = on, since that's what this hittest function is looking to match (or handles.fakeax/fakerax):
obj = hittest(handles.fig);
p = ancestor(obj,'axes');
if ~isempty(p)
    %Is this axes a member of handles.allgraphs?
    idx = find(handles.allgraphs==p | handles.fakeax==p | handles.fakerax==p);
    if ~isempty(idx)
        thistype = get(handles.allgraphs(idx),'userdata');
        if ~isempty(which(['scrollwheelfcn',thistype]))
            eval(['scrollwheelfcn',thistype,'(p,idx,eventdata.VerticalScrollCount);'])
            return
        end
    end
end



%If nothing above happened, scroll the workspace:
currentpos=get(handles.vscroll,'value');
newpos=currentpos+eventdata.VerticalScrollCount*-100; %adjust this number to control scrolling speed

if newpos<get(handles.vscroll,'min')
    set(handles.vscroll,'value',get(handles.vscroll,'min'));
elseif newpos>get(handles.vscroll,'max')
    set(handles.vscroll,'value',get(handles.vscroll,'max'));
else
    set(handles.vscroll,'value',newpos)
end

vertscroll(handles.fig,[],handles.fig);