function [newxtick,newytick,newztick]=synchticks(handles,targetaxes,axesformat,oldxtick,oldytick,oldztick)
%This function must be run after each time the targetaxes position is set (or at least once before then doing anything that interacts with the ticks.
%This function checks if the tick marks have changed and, if so, makes new tick labels to match the new number of ticks.
%NOTE: when calling this function, the outputs are OLDxtick/ytick/ztick, since we refresh the old values with the new values.

newxtick=[];
newytick=[];
newztick=[];

switch axesformat
    case {'matrix','row'}
        %do nothing, this function is only useable on single axes:
        
        return
        
    otherwise
        changedticks='';
        newticks={};
        
        if ~isempty(oldxtick)
            newxtick = get(targetaxes,'xtick');
            if ~isequal(oldxtick,newxtick)
                changedticks(end+1)='x';
                newticks{1}=newxtick;
            end
        end
        
        if ~isempty(oldytick)
            newytick = get(targetaxes,'ytick');
            if ~isequal(oldytick,newytick)
                changedticks(end+1)='y';
                newticks{2}=newytick;
            end
        end
        
        if ~isempty(oldztick)
            newztick = get(targetaxes,'ztick');
            if ~isequal(oldztick,newztick)
                changedticks(end+1)='z';
                newticks{3}=newztick;
            end
        end
        
        if ~isempty(changedticks)
            newaxeschangelistener(targetaxes,[],changedticks,newticks,handles);
        end
end

