function drawtab(src,eventdata)
%
% RAVE Rapid Analysis and Visualization Environment
% Copyright (C) 2011 Georgia Tech Research Corporation
% ALL RIGHTS RESERVED
% 
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU General Public License
% as published by the Free Software Foundation; version 2
% of the License.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.

ravechangetab(src,[]);
handles=guidata(src);
set(handles.infobar,'string','');
handles.activetab='draw';
guidata(src,handles);

%move front tabs to front if necessary
set(handles.fronttabaxes,'position',handles.backtabposition)
set(handles.backtabaxes,'position',handles.fronttabposition)
[x,y,v]=calculatetabprofile(handles.fronttabprofile,.1,1,0); %#ok<NASGU>
set(handles.fronttablines,'xdata',x,'ydata',y)

set(handles.infobar,'string','');

delete(handles.tabobjects)

%raise this tab to top
[x,y,v]=calculatetabprofile(handles.backtabprofile,.1,6,1); %#ok<NASGU>
set(handles.backtablines,'xdata',x,'ydata',y)

origin=get(handles.tabaxes,'position');

%% text headers
ongraphtext=text(.15-.10317,.95*1.0317-.0317,'Draw on Graph','horizontalalignment','left','backgroundcolor',handles.colors.tabbg,...
    'parent',handles.tabaxes,'fontsize',handles.fonts.titlesize,'fontname',handles.fonts.title,'color',handles.colors.title);
% onwstext=text(.15-.10317,.55*1.0317-.0317,'... on Workspace','horizontalalignment','left','backgroundcolor',handles.colors.tabbg,...
%     'parent',handles.tabaxes,'fontsize',handles.fonts.titlesize,'fontname',handles.fonts.title,'color',handles.colors.title);

%% DRAW ON GRAPH:

lineword=text(.25-.10317,.92*1.0317-.0317,'Line:','fontname','arial','fontsize',10,'fontweight','bold','parent',handles.tabaxes);

horizontalbutton=uicontrol('position',[origin(1)+55 origin(2)+540 90 26],'style','togglebutton',...
    'string','Horizontal','callback',@lineongraph,'backgroundcolor',handles.colors.buttonbg,...
    'fontname','arial narrow','fontsize',12,'parent',handles.fig','tag','hgraphline');
verticalbutton=uicontrol('position',[origin(1)+155 origin(2)+540 90 26],'style','togglebutton',...
    'string','Vertical','callback',@lineongraph,'backgroundcolor',handles.colors.buttonbg,...
    'fontname','arial narrow','fontsize',12,'parent',handles.fig,'tag','vgraphline');

% fillword=text(.25-.10317,.72*1.0317-.0317,'Fill:','fontname','arial','fontsize',10,'fontweight','bold','parent',handles.tabaxes);


%linestyleoptions:
offcolor=[.5 .5 .5];
oncolor=handles.colors.text;
linestyleaxes=axes('units','pixels','position',[origin(1)+195 origin(2)+478 50 20],...
    'xlimmode','manual','ylimmode','manual','visible','off','nextplot','add','xcolor',[1 1 1],...
    'ycolor',[1 1 1],'zcolor',[1 1 1]);
line([0 1],[.9 .9],'linestyle','-','parent',linestyleaxes,'linewidth',2.5,'color',oncolor,'buttondownfcn',@lineblob_callback,'tag','lineblob');
line([0 1],[.62 .62],'linestyle','--','parent',linestyleaxes,'linewidth',2.5,'color',offcolor,'buttondownfcn',@lineblob_callback,'tag','lineblob')
line([0 1],[.38 .38],'linestyle',':','parent',linestyleaxes,'linewidth',2.5,'color',offcolor,'buttondownfcn',@lineblob_callback,'tag','lineblob')
line([0 1],[.1 .1],'linestyle','-.','parent',linestyleaxes,'linewidth',2.5,'color',offcolor,'buttondownfcn',@lineblob_callback,'tag','lineblob')




graphlinecolor=uicontrol('position',[origin(1)+95 origin(2)+476 20 20],...
    'style','pushbutton','string','','backgroundcolor',handles.prefs.annotationcolor,'value',0,...
    'callback',@linecolor_callback,'userdata',[1 1 1;0 0 0;2 0 0],'tag','graphlinecolor');


widthword=text(.30-.10317,.835*1.0317-.0317,'Line Width:','fontname','arial','fontsize',10,'fontweight','normal','parent',handles.tabaxes);
colorword=text(.30-.10317,.780*1.0317-.0317,'Color:','fontname','arial','fontsize',10,'fontweight','normal','parent',handles.tabaxes);
styleword=text(.62-.10317,.780*1.0317-.0317,'Style:','fontname','arial','fontsize',10,'fontweight','normal','parent',handles.tabaxes);

%width slider:
[jslider hslider]=javacomponent('javax.swing.JSlider',[origin(1)+150 origin(2)+510 100 27]);
jslider.setPaintTicks(1)
jslider.setSnapToTicks(1)
jslider.setMinimum(1)
jslider.setMaximum(5)
jslider.setMajorTickSpacing(1);
jslider.setValue(2);
set(jslider,'background',java.awt.Color.white)
%set(jslider,'StateChangedCallback',{@jslider_Callback,handles.fig});


widthaxes=axes('units','pixels','position',[origin(1)+145 origin(2)+505 110 5],'visible','off');
gauge=imread('widthgauge.bmp');
image(gauge,'parent',widthaxes)
set(widthaxes,'visible','off');


lineinfotext =text(.25-.10317,.70*1.0317-.0317,{'Right click line to change color';'Double click line to change';'    other properties';'Shift+Click line to delete'},...
    'fontname','arial','fontsize',10,'fontweight','normal','parent',handles.tabaxes);


handles.tabobjects=[ongraphtext ...
    lineword horizontalbutton verticalbutton linestyleaxes graphlinecolor widthword ...
    colorword styleword widthaxes hslider lineinfotext];

guidata(src,handles);



function newtextbox(src,ev) %#ok<INUSD>
handles=guidata(src);

ravenewgraph(handles.fig,[],'textbox')




function edittextbox(src,ev) %#ok<INUSD>


function edgecheck_callback(src,ev)


function fontpicker_callback(src,ev) %#ok<INUSD>

handles=guidata(src);
deletebutton=findobj(handles.tabobjects,'tag','deletebutton');
set(deletebutton,'value',0);

fontpicker=findobj(handles.tabobjects,'tag','fontpicker');
fontsizer=findobj(handles.tabobjects,'tag','fontsizer');
boldbutton=findobj(handles.tabobjects,'tag','boldbutton');
italicbutton=findobj(handles.tabobjects,'tag','italicbutton');
%underlinebutton=findobj(handles.tabobjects,'tag','underlinebutton');

fontlist=get(fontpicker,'string');
fontname=fontlist(get(fontpicker,'value'));

sizelist=get(fontsizer,'string');
fontsize=str2double(sizelist{get(fontsizer,'value')});

if get(boldbutton,'value') && get(italicbutton,'value')
    fontstyle=3;
elseif get(boldbutton,'value')
    fontstyle=1;
elseif get(italicbutton,'value')
    fontstyle=2;
else
    fontstyle=4;
end

handles.draw.fontname=fontname;
handles.draw.fontsize=fontsize;
handles.draw.fontstyle=fontstyle;

guidata(src,handles);





function fontdown_callback(src,ev)
handles=guidata(src);
fontsizer=findobj(handles.tabobjects,'tag','fontsizer');

value=get(fontsizer,'value');
if value>=2
    value=value-1;
    set(fontsizer,'value',value);
    fontpicker_callback(src,ev);
end


function fontup_callback(src,ev)
handles=guidata(src);
fontsizer=findobj(handles.tabobjects,'tag','fontsizer');
maxvalue=numel(get(fontsizer,'string'));

value=get(fontsizer,'value');
if value<maxvalue
    value=value+1;
    set(fontsizer,'value',value);
    fontpicker_callback(src,ev);
end


function deletebutton_callback(src,ev) %#ok<INUSD>
handles=guidata(src);
if get(src,'value')
    set(handles.infobar,'string','Erase Mode: Double-click annotations to erase.')
else
    set(handles.infobar,'string','')
end
    
    
    
function lineongraph(src,ev) %#ok<INUSD>
handles=guidata(src);
if get(src,'value')

mode=get(src,'string');

hgraphline=findobj('tag','hgraphline');
vgraphline=findobj('tag','vgraphline');

set([hgraphline vgraphline],'value',0);
set(src,'value',1);

set(handles.infobar,'string',['Click on graph to place ',lower(mode),' line.']);
else
    set(handles.infobar,'string','')
end

set(handles.activegraph,'buttondownfcn',@drawline,'hittest','on')


function drawline(src,ev) %#ok<INUSD> %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

handles=guidata(src);
%set(handles.fig,'windowbuttondownfcn',[]);

%check that they clicked on current graph:
if gco~=handles.activegraph
    return
end

clicked=get(handles.activegraph,'currentpoint');

xclick=clicked(1,1,1);
yclick=clicked(1,2,1);
handles.temp.startx=xclick;
handles.temp.starty=yclick;

colorblob=findobj(handles.tabobjects,'tag','graphlinecolor');
color=get(colorblob,'backgroundcolor');

hbutton=findobj(handles.tabobjects,'tag','hgraphline');
vbutton=findobj(handles.tabobjects,'tag','vgraphline');

mslider=findobj(handles.tabobjects,'type','hgjavacomponent');
jslider=get(mslider,'javapeer');
width=jslider.getValue;

style=findobj(handles.tabobjects,'tag','lineblob','color',handles.colors.text);

if get(hbutton,'value')
    l=line(get(handles.activegraph,'xlim'),[yclick yclick],'parent',handles.activegraph,'tag','annotation','color',color,'linewidth',width,...
        'buttondownfcn',@lineobject_callback,'linestyle',get(style,'linestyle'));
elseif get(vbutton,'value')
   l=line([xclick,xclick],get(handles.activegraph,'ylim'),'parent',handles.activegraph,'tag','annotation','color',color,'linewidth',width,...
        'buttondownfcn',@lineobject_callback,'linestyle',get(style,'linestyle'));
else
    return
end

linedata.handles=l;
linedata.delete=1;

set(l,'userdata',linedata);

set(handles.activegraph,'buttondownfcn','','hittest','off');
set([hbutton vbutton],'value',0);




function lineblob_callback(src,ev) %#ok<INUSD>

handles=guidata(src);

lineblobs=findobj(handles.tabobjects,'tag','lineblob');

offcolor=[.5 .5 .5];
set(lineblobs,'color',offcolor)
set(src,'color',handles.colors.text)


function linecolor_callback(src,ev) %#ok<INUSD>
handles=guidata(src);

pos=get(handles.fig,'position');

handles.prefs.annotationcolor=ravecolorchooser([pos(1)+pos(3)/2-200 pos(2)+pos(4)/2-150 0 0],handles.prefs.annotationcolor,'Pick a Color');
set(src,'backgroundcolor',handles.prefs.annotationcolor)

guidata(src,handles);

function ravedeleteannotation(src,ev) %#ok<INUSD>
handles=guidata(src);

deletemode=findobj(handles.tabobjects,'tag','deletebutton');
if get(deletemode,'value')

    type=get(handles.fig,'selectiontype');
    if strcmpi(type,'open')
        delete(gco)
    end
end


function textblob_callback(src,ev)
%callback for textbox text color buttons.


