function setuptab(src,eventdata) %#ok<INUSD>
%
% RAVE Rapid Analysis and Visualization Environment
% Copyright (C) 2011 Georgia Tech Research Corporation
% ALL RIGHTS RESERVED
% 
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU General Public License
% as published by the Free Software Foundation; version 2
% of the License.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.

ravechangetab(src,[]);
handles=guidata(src);
set(handles.infobar,'string','');
handles.activetab='setup';
guidata(src,handles);

%move front tabs to front if necessary
set(handles.fronttabaxes,'position',handles.backtabposition)
set(handles.backtabaxes,'position',handles.fronttabposition)
[x,y,v]=calculatetabprofile(handles.fronttabprofile,.1,1,0); %#ok<NASGU>
set(handles.fronttablines,'xdata',x,'ydata',y)

delete(handles.tabobjects);

set(handles.infobar,'string','');

%raise this tab to top
[x,y,v]=calculatetabprofile(handles.backtabprofile,.1,6,1); %#ok<NASGU>
set(handles.backtablines,'xdata',x,'ydata',y)

origin=get(handles.tabaxes,'position');


%% text headers
preferencestext=text(.15-.10317,.95*1.0317-.0317,'Preferences','horizontalalignment','left','backgroundcolor',handles.colors.tabbg,...
    'parent',handles.tabaxes,'fontsize',18*handles.fonts.titlescale,'fontname',handles.fonts.title,'color',handles.colors.title);
colorstext=text(.15-.10317,.85*1.0317-.0317,'Colors','horizontalalignment','left','backgroundcolor',handles.colors.tabbg,...
    'parent',handles.tabaxes,'fontsize',18*handles.fonts.titlescale,'fontname',handles.fonts.title,'color',handles.colors.title);
quicktext=text(.15-.10317,.70*1.0317-.0317-.17,'Quick Prefs','horizontalalignment','left','backgroundcolor',handles.colors.tabbg,...
    'parent',handles.tabaxes,'fontsize',18*handles.fonts.titlescale,'fontname',handles.fonts.title,'color',handles.colors.title);


%% buttons

changeprefsbutton=uicontrol('position',[origin(1)+55 origin(2)+550 170 30],'style','pushbutton',...
    'string','Change Default Directory','callback',@ravechangeprefs,'backgroundcolor',handles.colors.buttonbg,...
    'fontname','arial narrow','fontsize',10);

changecolorsbutton=uicontrol('position',[origin(1)+55 origin(2)+485 170 30],'style','pushbutton',...
    'string','Change Variable Colors','callback',@raveeditcolors,'backgroundcolor',handles.colors.buttonbg,...
    'fontname','arial narrow','fontsize',12,'enable','off','visible','off');

changethemebutton=uicontrol('position',[origin(1)+55 origin(2)+450+35 170 30],'style','pushbutton',...
    'string','Change Theme Colors','callback',@raveedittheme,'backgroundcolor',handles.colors.buttonbg,...
    'fontname','arial narrow','fontsize',12,'enable','on');

changefontsbutton=uicontrol('position',[origin(1)+55 origin(2)+415+35 170 30],'style','pushbutton',...
    'string','Change Fonts','callback',@raveeditfonts,'backgroundcolor',handles.colors.buttonbg,...
    'fontname','arial narrow','fontsize',12,'enable','on');

wscolortext=uicontrol('position',[origin(1)+55 origin(2)+400 180 24],'style','text',...
    'string','Workspace Background:','backgroundcolor',handles.colors.tabbg,...
    'fontname','arial narrow','fontsize',10,'hor','left');


gridvis=true;
if strcmp(get(handles.lgrid(1),'visible'),'off')
    gridvis=false;
end

gridcheck=uicontrol('position',[origin(1)+90 origin(2)+366 100 20],'style','checkbox',...
    'string','','backgroundcolor',handles.colors.tabbg,'value',gridvis,...
    'fontname','arial narrow','fontsize',10,'hor','left','callback',@gridcheck_callback);

gridcolortext=uicontrol('position',[origin(1)+118 origin(2)+360 100 24],'style','text',...
    'string','Grid Lines:','backgroundcolor',handles.colors.tabbg,...
    'fontname','arial narrow','fontsize',10,'hor','left');

wscolorbutton=uicontrol('position',[origin(1)+178 origin(2)+404 24 24],'style','pushbutton',...
    'string','','callback',@changewscolor,'tag','wscolorbutton',...
    'fontname','arial narrow','fontsize',12,'backgroundcolor',handles.colors.wsbg);

gridcolorbutton=uicontrol('position',[origin(1)+178 origin(2)+364 24 24],'style','pushbutton',...
    'string','','callback',@changegridcolor,'backgroundcolor',handles.colors.wsgrid,...
    'fontname','arial narrow','fontsize',12,'tag','gridcolorbutton');


%quickprefs checkboxes:
resizecheck=uicontrol('position',[origin(1)+35 origin(2)+320-25 220 20],'style','checkbox',...
    'string','Rave window is resizable','callback',@changequickprefs,'backgroundcolor',handles.colors.tabbg,...
    'fontname','arial narrow','fontsize',10,'value',handles.prefs.isresizable,'tag','resizecheck','visible','on');

autorastercheck=uicontrol('position',[origin(1)+35 origin(2)+290-25 220 20],'style','checkbox',...
    'string','Auto-rasterize graphs','callback',@changequickprefs,'backgroundcolor',handles.colors.tabbg,...
    'fontname','arial narrow','fontsize',10,'value',handles.prefs.alwaysrasterize,'tag','autorastercheck');

snaptogridcheck=uicontrol('position',[origin(1)+35 origin(2)+260-25 220 20],'style','checkbox',...
    'string','Snap graphs to grid','callback',@changequickprefs,'backgroundcolor',handles.colors.tabbg,...
    'fontname','arial narrow','fontsize',10,'value',handles.prefs.snaptogrid,'tag','snaptogridcheck');

resolutiontext=text(.29-.10317,.505*1.0317-.0317-.17,'Grid Resolution:','parent',handles.tabaxes,...
    'backgroundcolor',handles.colors.tabbg,...
    'fontname','arial narrow','fontsize',10,'horizontalalignment','left','fontweight','normal');

%smoothness slider:
% ui=javax.swing.UIManager;
%ui.setLookAndFeel(javax.swing.plaf.metal.MetalLookAndFeel);
%ui.setLookAndFeel(com.sun.java.swing.plaf.windows.WindowsLookAndFeel);

[jslider hslider]=javacomponent('javax.swing.JSlider',[origin(1)+140 origin(2)+214-25 110 40]);
jslider.setPaintTicks(1)

jslider.setSnapToTicks(1)
jslider.setMinimum(1)
jslider.setMaximum(3)
jslider.setMajorTickSpacing(1);
jslider.setValue(handles.prefs.gridmode);
set(jslider,'background',java.awt.Color.white)
set(jslider,'foreground',java.awt.Color.black)
set(jslider,'StateChangedCallback',{@jslider_Callback,handles.fig});

resolutiontext2=uicontrol('position',[origin(1)+133 origin(2)+200-25 120 20],...
    'style','text','string','Large                        Fine','backgroundcolor',handles.colors.tabbg,...
    'fontname','arial','fontsize',8,'horizontalalignment','left','fontweight','normal');

%handles.javacomps=jslider;

if strcmp(handles.prefs.interpreter,'none')
    interpreter=0;
else
    interpreter=1;
end
interpretercheck=uicontrol('position',[origin(1)+35 origin(2)+180-25 220 20],'style','checkbox',...
    'string','Interpret variables names as TeX strings','callback',@changequickprefs,'backgroundcolor',handles.colors.tabbg,...
    'fontname','arial narrow','fontsize',10,'value',interpreter,'tag','interpretercheck');

alwaysupdatecheck=uicontrol('position',[origin(1)+35 origin(2)+150-25 220 20],'style','checkbox',...
    'string','Update linked graphs instantly','callback',@changequickprefs,'backgroundcolor',handles.colors.tabbg,...
    'fontname','arial narrow','fontsize',10,'value',handles.prefs.alwaysupdate,'tag','alwaysupdatecheck');

alwaysupdateinfo=uicontrol('position',[origin(1)+50 origin(2)+150-25-75 200 70],'style','text',...
    'string','This property is only used when autorasterize is turned off. Computationally intensive.','backgroundcolor',handles.colors.tabbg,...
    'fontname','arial narrow','fontsize',10,'horizontalalignment','left');

selectbestcheck=uicontrol('position',[origin(1)+35 origin(2)+150-25-60 220 20],'style','checkbox',...
    'string','Auto-select best point after','callback',@changequickprefs,'backgroundcolor',handles.colors.tabbg,...
    'fontname','arial narrow','fontsize',10,'value',handles.prefs.autoselectbest,'tag','selectbestcheck');
selectbestinfo=uicontrol('position',[origin(1)+52 origin(2)+150-25-78 200 20],'style','text',...
    'string','using optimizer or changing preferences','backgroundcolor',handles.colors.tabbg,...
    'fontname','arial narrow','fontsize',10,'horizontalalignment','left');

setxdialscheck=uicontrol('position',[origin(1)+35 origin(2)+150-25-60-45 220 20],'style','checkbox',...
    'string','Set "Current Point" whenever','callback',@changequickprefs,'backgroundcolor',handles.colors.tabbg,...
    'fontname','arial narrow','fontsize',10,'value',handles.prefs.setxdialswhensingleselected,'tag','setxdialscheck');
setxdialsinfo=uicontrol('position',[origin(1)+52 origin(2)+150-25-78-45 200 20],'style','text',...
    'string','a single point is selected','backgroundcolor',handles.colors.tabbg,...
    'fontname','arial narrow','fontsize',10,'horizontalalignment','left');

handles.tabobjects=[preferencestext colorstext changeprefsbutton changecolorsbutton quicktext resizecheck ...
    autorastercheck snaptogridcheck resolutiontext resolutiontext2 interpretercheck hslider alwaysupdatecheck changethemebutton alwaysupdateinfo ...
    selectbestcheck selectbestinfo setxdialscheck setxdialsinfo changefontsbutton ...
    wscolortext gridcolortext wscolorbutton gridcolorbutton gridcheck];




guidata(src,handles);


%% callbacks:
function ravechangeprefs(src,eventdata) %#ok<INUSD>
handles=guidata(src);

set(0,'userdata',get(handles.fig,'pos'));

h=ravechangeprefsgui;
uiwait(h);

handles=guidata(src);

%get results of prefernce change gui:
newprefs=get(0,'userdata');

if ischar(newprefs);return;end

%update handles:
handles.prefs.defaultdir=newprefs.newdir;

%refresh handles:
guidata(src,handles);


function changequickprefs(src,eventdata) %#ok<INUSD>
handles=guidata(src);

resizecheck=findobj(handles.tabobjects,'tag','resizecheck');
autorastercheck=findobj(handles.tabobjects,'tag','autorastercheck');
snaptogridcheck=findobj(handles.tabobjects,'tag','snaptogridcheck');
interpretercheck=findobj(handles.tabobjects,'tag','interpretercheck');
alwaysupdatecheck=findobj(handles.tabobjects,'tag','alwaysupdatecheck');
selectbestcheck=findobj(handles.tabobjects,'tag','selectbestcheck');
setxdialscheck=findobj(handles.tabobjects,'tag','setxdialscheck');



if get(resizecheck,'value') %to always show grabbers, even when highlight is turned off. 
    set(handles.fig,'resize','on')
    handles.prefs.isresizable=true;
else
    set(handles.fig,'resize','off')
    handles.prefs.isresizable=false;
end

if get(autorastercheck,'value')
    handles.prefs.alwaysrasterize=1;
else
    handles.prefs.alwaysrasterize=0;
end

if get(snaptogridcheck,'value')
    handles.prefs.snaptogrid=1;
    if handles.prefs.gridmode==1
        handles.snapsize=handles.prefs.gridsize;
    elseif handles.prefs.gridmode==2
        handles.snapsize=handles.prefs.gridsize/2;
    else
        handles.snapsize=handles.prefs.gridsize/4;
    end
else
    handles.prefs.snaptogrid=0;
    handles.snapsize=1;
end

if get(interpretercheck,'value')
    handles.prefs.interpreter='tex';
else
    handles.prefs.interpreter='none';
end

if get(alwaysupdatecheck,'value')
    handles.prefs.alwaysupdate=1;
else
    handles.prefs.alwaysupdate=0;
end

if get(selectbestcheck,'value')
    handles.prefs.autoselectbest=1;
else
    handles.prefs.autoselectbest=0;
end

if get(setxdialscheck,'value')
    handles.prefs.setxdialswhensingleselected=1;
else
    handles.prefs.setxdialswhensingleselected=0;
end

prefspath=which('raveprefs.mat');
raveprefs=handles.prefs;
save(prefspath,'raveprefs');
guidata(src,handles);



function jslider_Callback(src,eventdata,fighandle) %#ok<INUSL>

moving = get(src,'ValueIsAdjusting');
if strcmp(moving,'off')
    return
end

handles=guidata(fighandle);
udata=get(handles.fakeax(handles.activeindex),'userdata');

handles.prefs.gridmode=src.getValue;

raveprefs=handles.prefs;
prefspath=which('raveprefs.mat');
save(prefspath,'raveprefs');

set(handles.fakeax(handles.activeindex),'userdata',udata)

if get(handles.showgridbutton,'value')
    if handles.prefs.gridmode==1
        set(handles.lgrid,'visible','on')
        set(handles.mgrid,'visible','off')
        set(handles.sgrid,'visible','off')
        handles.snapsize=handles.prefs.gridsize;
    elseif handles.prefs.gridmode==2
        set(handles.lgrid,'visible','on')
        set(handles.mgrid,'visible','on')
        set(handles.sgrid,'visible','off')
         handles.snapsize=handles.prefs.gridsize/2;
    else
        set(handles.lgrid,'visible','on')
        set(handles.mgrid,'visible','on')
        set(handles.sgrid,'visible','on')
         handles.snapsize=handles.prefs.gridsize/4;
    end
end

if ~handles.prefs.snaptogrid
    handles.snapsize=1;
end

guidata(fighandle,handles)



function raveeditcolors(src,ev) %#ok<INUSD>

hhh=raveeditcolorsgui(src,[]);
uiwait(hhh);

handles=guidata(src);

%update colormap:
% load raveprefs
% handles.prefs=raveprefs;
% 
% newcolormap=getvariablecolors(256,raveprefs.defaultcolormap);
% set(handles.fig,'colormap',newcolormap);
% guidata(src,handles);


function raveedittheme(src,ev)

handles=guidata(src);

theseblockers=findobj(handles.allblockers(ishandle(handles.allblockers)),'facecolor',handles.colors.wsbg);
otherblockers=setdiff(handles.allblockers(ishandle(handles.allblockers)),handles.allblockers(handles.activeindex));
framez=findobj(handles.fig,'type','axes','color',handles.colors.frame);
texts=findobj(handles.fig,'type','text','color',handles.colors.text);
titles=findobj(handles.fig,'type','text','color',handles.colors.title);
tints=findobj(handles.fig,'type','text','color',handles.colors.texttint);
tablines=findobj([handles.fronttabaxes handles.backtabaxes],'color',handles.colors.tabfg);
tabbgs=findobj(handles.fig,'tag','tabbg');

hhh=raveeditthemecolorsgui(src,[]);
uiwait(hhh);

load raveprefs
handles.colors=raveprefs.colors;
guidata(src,handles);

lgrid=findobj(handles.mainaxes,'tag','lgrid');
mgrid=findobj(handles.mainaxes,'tag','mgrid');
sgrid=findobj(handles.mainaxes,'tag','sgrid');

set(lgrid,'color',handles.colors.wsgrid)
set(mgrid,'color',(handles.colors.wsgrid+handles.colors.wsbg)/2)
set(sgrid,'color',(handles.colors.wsgrid+handles.colors.wsbg)/2)
set(findobj(handles.mainaxes,'tag','wspanelborder'),'color',handles.colors.wsgrid)
set(otherblockers,'edgecolor',handles.colors.wsgrid)
set(theseblockers,'facecolor',handles.colors.wsbg)
set(handles.mainaxes,'color',handles.colors.wsbg)
set(framez,'color',handles.colors.frame)
set(handles.wspanel,'foregroundcolor',handles.colors.frame,'highlightcolor',handles.colors.frame,'shadowcolor',handles.colors.frame);
set(handles.topmargin,'xcolor',handles.colors.frame,'ycolor',handles.colors.frame,'zcolor',handles.colors.frame);

set(titles,'color',handles.colors.title)
set(texts,'color',handles.colors.text)
set(tints,'color',handles.colors.texttint)
set(tablines,'color',handles.colors.tabfg)
set(tabbgs,'facecolor',handles.colors.tabbg)


wscolorbutton=findobj(handles.tabobjects,'tag','wscolorbutton');
gridcolorbutton=findobj(handles.tabobjects,'tag','gridcolorbutton');

set(wscolorbutton,'backgroundcolor',handles.colors.wsbg);
set(gridcolorbutton,'backgroundcolor',handles.colors.wsgrid);

function raveeditfonts(src,ev)
handles=guidata(src);

load raveprefs
oldprefs=raveprefs;

hhh=raveeditthemefontsgui(src,[]);
uiwait(hhh);

load raveprefs

handles.fonts=raveprefs.fonts;
guidata(handles.fig,handles);

titles=findall(handles.fig,'fontname',oldprefs.fonts.title);
sizes=get(titles,'fontsize');
set(titles,'fontname',handles.fonts.title);
set(titles,{'fontsize'},num2cell(cell2mat(sizes)./oldprefs.fonts.titlescale*handles.fonts.titlescale));

tabs=findobj(handles.fig,'fontname',oldprefs.fonts.tab);
sizes=get(tabs,'fontsize');
set(tabs,'fontname',handles.fonts.tab);
set(tabs,{'fontsize'},num2cell(cell2mat(sizes)./oldprefs.fonts.tabscale*handles.fonts.tabscale));

%clear a persistent var related to fonts:
clear ravemovecustomticks

%recreate FontMetrics:
ravemakefontmetrics(handles.fig,[]);



function changegridcolor(src,ev)
handles=guidata(src);

%also change color of blockers that havent been assigned a different color:
lgrid1=findobj(handles.mainaxes,'tag','lgrid');
lgrid2=findobj(handles.explorer,'tag','lgrid');
mgrid=findobj(handles.mainaxes,'tag','mgrid');
sgrid=findobj(handles.mainaxes,'tag','sgrid');

%udata.format.linecolor=uisetcolor(udata.format.linecolor);
handles.colors.wsgrid=ravecolorchooser(handles.fig,handles.colors.wsgrid,'Pick a Color');

set(lgrid1,'color',handles.colors.wsgrid);
set(lgrid2,'color',(handles.colors.wsgrid+handles.colors.wsbg)/2);
set(mgrid,'color',(handles.colors.wsgrid+handles.colors.wsbg)/2);
set(sgrid,'color',(handles.colors.wsgrid+handles.colors.wsbg)/2);
set(findobj(handles.mainaxes,'tag','wspanelborder'),'color',handles.colors.wsgrid)

set(src,'backgroundcolor',handles.colors.wsgrid);

idx=ishandle(handles.allblockers);
idx(handles.activeindex)=false;

set(handles.allblockers(idx),'edgecolor',handles.colors.wsgrid);

prefpath=which('raveprefs.mat');
load raveprefs
raveprefs.colors.wsgrid=handles.colors.wsgrid; %#ok<STRNU>
save(prefpath,'raveprefs');


guidata(src,handles);




function changewscolor(src,ev)
handles=guidata(src);

%also change color of blockers that havent been assigned a different color:
theseblockers=findobj(handles.allblockers(ishandle(handles.allblockers)),'facecolor',handles.colors.wsbg);

%udata.format.linecolor=uisetcolor(udata.format.linecolor);
handles.colors.wsbg=ravecolorchooser(handles.fig,handles.colors.wsbg,'Pick a Color');
set(theseblockers,'facecolor',handles.colors.wsbg);
set(handles.mainaxes,'color',handles.colors.wsbg);
set(handles.explorer,'color',handles.colors.wsbg);
set(src,'backgroundcolor',handles.colors.wsbg);

mgrid=findobj(handles.mainaxes,'tag','mgrid');
sgrid=findobj(handles.mainaxes,'tag','sgrid');

set(mgrid,'color',(handles.colors.wsgrid+handles.colors.wsbg)/2)
set(sgrid,'color',(handles.colors.wsgrid+handles.colors.wsbg)/2)

prefpath=which('raveprefs.mat');
load raveprefs
raveprefs.colors.wsbg=handles.colors.wsbg;
save(prefpath,'raveprefs');

guidata(src,handles);


%update all images in case they use a transparent background:
othergraphs=[];
originalindex=handles.activeindex;
for g=1:numel(handles.allgraphs)
    if ishandle(handles.allgraphs(g))
        if strcmp(get(handles.allgraphs(g),'userdata'),'image')
            othergraphs(end+1)=g;
        end
    end
    
    for ai=othergraphs
        handles.activeindex=ai;
        
        othergraph=handles.allgraphs(ai);
        thistype=get(othergraph,'userdata'); %type of other graph in this analysis
        handles.activetype=thistype;
        handles.activegraph=othergraph;
        guidata(handles.fig,handles);
        eval(['ravecreate',lower(thistype),'(handles.fig,[]);']);
        handles=guidata(handles.fig); %refresh handles;
        
    end

end
    
othergraph=handles.allgraphs(originalindex);
thistype=get(othergraph,'userdata'); %type of other graph in this analysis

handles.activeindex=originalindex;
handles.activetype=thistype;
handles.activegraph=othergraph;
guidata(handles.fig,handles);



function gridcheck_callback(hObject,eventdata)
handles=guidata(hObject);
uicontrol(handles.dummyobj);

%do not alter the currently selected graph, or any annotation class graph.
changethese=false(size(handles.allgraphs));

for c=1:numel(changethese)
    if ishandle(handles.allgraphs(c)) && handles.allgraphs(c)~=handles.activegraph && ~strcmp(handles.graphinfo.(get(handles.allgraphs(c),'userdata')).class,'annotation')
        changethese(c)=true;
    end
end

if get(hObject,'value')
    if handles.prefs.gridmode==1
        set(handles.lgrid,'visible','on')
    elseif handles.prefs.gridmode==2
        set(handles.lgrid,'visible','on')
        set(handles.mgrid,'visible','on')
    else
        set(handles.lgrid,'visible','on')
        set(handles.mgrid,'visible','on')
        set(handles.sgrid,'visible','on')
    end
    
    set(handles.allblockers(changethese),'edgecolor',handles.colors.wsgrid)
    
else
    set(handles.sgrid,'visible','off')
    set(handles.mgrid,'visible','off')
    set(handles.lgrid,'visible','off')
    set(handles.allblockers(changethese),'edgecolor','none')
    
end



